﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Globalization;
using System.Threading;
using System.Web.Caching;

namespace MFCalculator
{
    public class BasePage : System.Web.UI.Page
    {
        public String SiteCulture
        {
            get
            {
                if (Cache[Session.SessionID + "SiteCulture"] == null)
                    Cache[Session.SessionID + "SiteCulture"] = "pt-PT";

                return Cache[Session.SessionID + "SiteCulture"].ToString();
            }
            set
            {
                switch (value.ToUpper())
                {
                    case "EN":
                        Cache[Session.SessionID + "SiteCulture"] = "en-US";
                        break;
                    default:
                        Cache[Session.SessionID + "SiteCulture"] = "pt-PT";
                        break;
                }
            }
        }

        protected override void InitializeCulture()
        {
            Thread.CurrentThread.CurrentCulture = CultureInfo.CreateSpecificCulture(SiteCulture);
            Thread.CurrentThread.CurrentUICulture = new CultureInfo(SiteCulture);

            base.InitializeCulture();
        }

        public MFC.Calculator GetCalculator(int fileId, int nFactor, int score, bool updateParameters)
        {
            string fullName = Server.MapPath("~/temporaryFiles/" + Session["GUID"].ToString() + "/") + Session[fileId].ToString();
            string key = fullName.GetHashCode().ToString();

            if (HttpContext.Current.Cache[key] == null || updateParameters)
            {
                CleanCalculator(fullName);

                // Build calculator
                var mfc = new MFC.Calculator(fullName, nFactor, score);
                HttpContext.Current.Cache.Add(key, mfc, null, DateTime.Now.AddHours(1), Cache.NoSlidingExpiration, CacheItemPriority.Normal, null);
            }

            return HttpContext.Current.Cache[key] as MFC.Calculator;
        }

        public void CleanCalculator(string fullName)
        {
            string key = fullName.GetHashCode().ToString();
            HttpContext.Current.Cache.Remove(key);
        }
    }
}
