﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Collections;
using System.Collections.Generic;

namespace MFCalculator
{
    public class Calculador
    {
        private int j;  // j: the number of (“joint”) items raised by both the father and the mother;
        private int f;  // f: the number of items raised by the father and not by the mother;
        private int m;  // m: the number of items raised by the mother and not by the father;
        private int N;  // N: is a normalization factor that ensures that j/N, f/N, and m/N never exceed 1.
        private int scoreVSfrenquency; // this number are a precent rage[0:100]
        private int min;
        private int max;

        private List<string> itemsM; // list of items raised by the mother with item filled zeros
        private List<string> itemsF; // list of items raised by the father with item filled zeros

        public Calculador()
        {
            j = 0;
            f = 0;
            m = 0;
            N = 0;
            scoreVSfrenquency = 0;
            itemsM = null;
            itemsF = null;
            min = 0;
        }

        public Calculador(int j_, int f_, int m_, int N_, int scoreVSfrenquency_, List<string> itemsM_, List<string> itemsF_)
        {
            j = j_;
            f = f_;
            m = m_;
            N = N_;
            scoreVSfrenquency = scoreVSfrenquency_;
            itemsM = itemsM_;
            itemsF = itemsF_;
            min = 0;
        }

        public Calculador(int N_, int scoreVSfrenquency_, List<string> itemsF_, List<string> itemsM_, int max_, int min_)
        {
            N = N_;
            scoreVSfrenquency = scoreVSfrenquency_;
            itemsM = itemsM_;
            itemsF = itemsF_;
            max = max_;
            min = min_;
            calculateValues();
        }


        //public double scoreSimilarity() {

        //    if ((j + f + m) != 0) 
        //        return sumScoreSimilarity() / (j + f + m);
        //    else
        //        return sumScoreSimilarity() / itemsM.Count;
        //}

        public double frenquencySimilarity()
        {
            double result = 0;
            float result21 = 0;
            result21 = (float)j / N;
            result21 = (float)Math.Sqrt((double)result21);
            double result22 = (1 - Math.Abs(Math.Sqrt(((float)f / N)) - Math.Sqrt((float)m / N)));
            result = ((result21 + result22) / 2);
            return result;
        }

        //public double mfOverallSimilarity(out double score, out double frenquency)
        //{
        //    int scoreVS = scoreVSfrenquency;
        //    int frenquencyVS = 100-scoreVS; 

        //    score = scoreSimilarity();
        //    frenquency = frenquencySimilarity();
        //    return ((scoreVS*0.01)*(score) + (frenquencyVS*0.01)*(frenquency));

        //}

        //private double sumScoreSimilarity()
        //{
        //    double result = 0;
        //    Double it1 = 0;
        //    Double it2 = 0;

        //    double diff = 0;
        //    if ((itemsM.Count != ItemsF.Count) || (itemsF == null) || (itemsM == null))
        //        return -1;

        //    int normalize = (max - min);
        //    //for (int i = 0; i < itemsM.Count; i++)
        //    //{
        //    //    Double.TryParse(itemsM[i].ToString(), out it1);
        //    //    Double.TryParse(itemsF[i].ToString(), out it2);
        //    //    if (normalize < it1)
        //    //        normalize = (int)it1;
        //    //    if (normalize < it2)
        //    //        normalize = (int)it2;
        //    //}


        //    for (int i = 0; i < itemsM.Count; i++) {
        //        it1 = 0; it2 = 0;
        //        Double.TryParse(itemsM[i].ToString(), out it1);
        //        Double.TryParse(itemsF[i].ToString(), out it2);

        //        diff = 0;

        //        if (it1 > 0)
        //            it1 = it1 / normalize;
        //        if (it2 > 0)
        //            it2 = it2 / normalize;

        //        diff = (it1 - it2);

        //        result += 1 - ((double)Math.Abs(diff));

        //    }

        //    return result;
        //}

        public double calculateMFOverallSimilarity(out double score, out double frenquency)
        { // reestruturar reescrever
            int scoreVS = scoreVSfrenquency;
            int frenquencyVS = 100 - scoreVS;

            score = calculateSimCatws();
            frenquency = frenquencySimilarity();
            return ((scoreVS * 0.01) * (score) + (frenquencyVS * 0.01) * (frenquency));

        }

        private double calculateSimCatws()
        {
            /*
             * 
             * sumwcom := j + f + m - sumwdif;
             * writeln('');
             * simcatws := sumwcom/(j+f+m);
             * 
             */
            Double simcatws = 0;
            Double auxSimcatws = (j + f + m);

            if (auxSimcatws != 0)
                simcatws = (j + f + m - calculateSumWDiff()) / (j + f + m);
            else
                simcatws = 1;


            return simcatws;
        }

        private double calculateSumWDiff()
        {
            Double diff = 0;
            int auxDiffF = 0;
            int auxDiffM = 0;

            //if ((max - min) != 0)
            //    auxMaxMin = (max - min);
            //else
            //    auxMaxMin = 1;

            for (int i = 0; i < itemsF.Count; i++)
            {
                auxDiffF = 0; auxDiffM = 0;
                Int32.TryParse(itemsF[i], out auxDiffF);
                Int32.TryParse(itemsM[i], out auxDiffM);
                if ((max - min) != 0)
                    diff = diff + (double)Math.Abs(auxDiffF - auxDiffM) / (max - min);
            }

            /* sumwdif := 0;
               for i:=1 to mc do begin
               sumwdif := sumwdif + abs(wo[i]-wy[i])/(max-min);
               end;
             */

            return diff;
        }

        private void calculateValues()
        {
            calculateF();
            calculateJ();
            calculateM();

        }

        private void calculateF()
        {
            int auxFF = 0;
            int auxFM = 0;
            f = 0;
            for (int i = 0; i < itemsF.Count; i++)
            {
                auxFF = 0; auxFM = 0;
                Int32.TryParse(itemsF[i], out auxFF);
                Int32.TryParse(itemsM[i], out auxFM);
                if ((Math.Abs(auxFF - min) > 0.00001) && (Math.Abs(auxFM - min) < 0.00001))
                    f++;
            }
        }

        private void calculateJ()
        {
            int auxJF = 0;
            int auxJM = 0;
            j = 0;
            for (int i = 0; i < itemsF.Count; i++)
            {
                auxJF = 0; auxJM = 0;
                Int32.TryParse(itemsF[i], out auxJF);
                Int32.TryParse(itemsM[i], out auxJM);
                if ((Math.Abs(auxJF - min) > 0.00001) && (Math.Abs(auxJM - min) > 0.00001))
                    j++;
            }
        }

        private void calculateM()
        {
            int auxMF = 0;
            int auxMM = 0;
            m = 0;
            for (int i = 0; i < itemsF.Count; i++)
            {
                auxMF = 0; auxMM = 0;
                Int32.TryParse(itemsF[i], out auxMF);
                Int32.TryParse(itemsM[i], out auxMM);
                if ((Math.Abs(auxMF - min) < 0.00001) && (Math.Abs(auxMM - min) > 0.00001))
                    m++;
            }
        }

        private void calculateMax()
        {
            int auxMax = 0;
            max = 0;
            for (int i = 0; i < itemsF.Count; i++)
            {
                auxMax = 0;
                Int32.TryParse(itemsF[i], out auxMax);
                if (auxMax > max)
                    max = auxMax;
                Int32.TryParse(itemsM[i], out auxMax);
                if (auxMax > max)
                    max = auxMax;
            }

        }

        private void calculateMin()
        {
            int auxMin = 0;
            min = max;
            for (int i = 0; i < itemsF.Count; i++)
            {
                auxMin = 0;
                Int32.TryParse(itemsF[i], out auxMin);
                if (auxMin < min)
                    min = auxMin;
                Int32.TryParse(itemsM[i], out auxMin);
                if (auxMin < min)
                    min = auxMin;
            }
            max = 7;
            min = 0;

        }

        public List<string> ItemsF
        {
            get { return itemsF; }
            set { itemsF = value; }
        }
        public List<string> ItemsM
        {
            get { return itemsM; }
            set { itemsM = value; }
        }

        public int getJ() { return j; }
        public void setJ(int J) { j = J; }

        public int getF() { return f; }
        public void setF(int F) { f = F; }

        public int getM() { return m; }
        public void setM(int M) { m = M; }

        public int getN() { return N; }
        public void setN(int N_) { N = N_; }

        public int getScoreVSfrenquency() { return scoreVSfrenquency; }
        public void setScoreVSfrenquency(int scoreVSfrenquency_) { scoreVSfrenquency = scoreVSfrenquency_; }
    }
}
