﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Collections;
using System.IO;

namespace MFCalculator
{
    public class Gtree
    {
        private ArrayList listaDados;
        private ArrayList listaNomes;
        private ArrayList matrixarray = new ArrayList();
        
       
        const int maxobject = 80;
        const int twiceobject = 160;
        const int maxsize = 3160;  
        const int linelength = 80;

        bool [] use;
        bool printnumbers = false;
        int ij, numobject, feed, numprox, numnode, rootnode, size, n, numgroup, whichgroup, nreduce, linesize, namelength;
        int[] parent, leafcount, grouptype, branchset, index, rootchild;
        int[,]   child;
        int[,]   group;
        double      addconstant, maxdis, rootd, rootarclength, diff, sum, sum1, sum2;
        double[]    prox, d, length, nodeposition, height, leafss;
        enum rootingtype { asis, minvar, specified }
        string[] name;
        rootingtype rooting;
        String      outfile;// = new StreamWriter("c:\\report.log");

        TextWriter  tw;

        //*********************************************
        // findbestroot
        double[] score;
        double psum; 
        double parentheight;
        double parentlength, othersum;
        int newparentcount, parentcount;
        double newparentheight, newparentss;
        double foo1, foo2, parentss;
        double fooheight, minscore, bsum;
        int goodnode, badnode,  goodchild,badchild;
        //*********************************************
        //*********************************************
        // report
        int start,stop,maxstop,node;
        double maxheight,stretch;
        char [] line;
        int [] yposition, topkid,bottomkid;
        int numleaf;

        //*********************************************


        





        //(************************************************************************)
        //(* ijfunction: converts the row and column of a lowerhalf matrix        *)
        //(* to the ordinal position of that entry in a vector (matrixarray)      *)
        //(************************************************************************)
        private int ijfunction(int i , int j){
            int resultado=0;
            if (i>j) {
                resultado = (((i-1)*(i-2)) / 2) + j;
            }
            else if (j>i) {
                resultado = (((j-1)*(j-2)) / 2) + i;
            }
            return resultado;
           //else writeln('error: i=j in ijfunction');
        }// (* ijfunction *)

        //(******************************************************************)
        //(* writematrix: write a matrixarray as lowerhalf matrix;          *)
        //(*   n = size of the matrix,                                      *)
        //(*   field = number of digits for each entry, and                 *)
        //(*   decplaces = number of digits after the decimal place         *)
        //(******************************************************************)
        // deixei de usar field decplaces porque tinham a Haver com as casas decimais e inteiras 
        private void writematrix(double[] mtx){
           int row,col;
           ij=0;
           int aux = 0;
           for (aux = 0; aux < mtx.Length; aux++)
               if (mtx[aux] == 0.0)
                   break;
           for (row = 0; ij < aux-1; row++)
           {
               for (col = 1; col < (row - 1); col++)
               {
                   ij = ij + 1;
                   outfile = mtx[ij].ToString();
                   if (col == feed)
                   {
                       writeln(outfile);
                   }
                   writeln(outfile);
               }
               writeln(outfile); writeln(outfile);
           }
          
        }//(* writematrix *)

        //(*************************************************************************)
        //(* chkmetric: check if proximities satisfy metric axioms, fix if not     *)
        //(*************************************************************************)
        private void chkmetric(){
            int  i,j,k,ij,ik,jk,xxij,xxjk;
            double diff,min;
            
            addconstant=0.0;
            min=0.0;
            maxdis=0.0;

            //(* check for positivity of distances *)
            for(ij=1; ij<numprox;ij++){
                
                if (prox[ij]<min)  min=prox[ij];
                if (prox[ij]>maxdis) maxdis=prox[ij];
            }

  
            if (min<0.0) addconstant=-min;
           
            //(* check every triple of objects for triangle inequality *)
            min=maxdis;
            xxij=0;
            for(i=0; i< (numobject-2) ; i++){
                xxij = xxij + i; // o que traduzi xxij=xxij+i-1;
                ij=xxij;
                xxjk=xxij;
                for(j=(i+1); j < (numobject-1) ;j++){
                    ij=ij+(j-1);
                    ik=ij;
                    xxjk = xxjk + j;  //o que traduzi xxjk=xxjk+j-1;
                    jk=xxjk;
                    for(k =(j+1); k < (numobject) ;k++ ){
                        ik=ik+(k-1);
                        jk=jk+(k-1);
                        if ((prox[jk]>=prox[ij]) && (prox[jk]>=prox[ik]))
                            diff=(prox[ij]+prox[ik])-prox[jk];
                        else if ((prox[ik]>=prox[ij]) && (prox[ik]>=prox[jk]))
                            diff=(prox[ij]+prox[jk])-prox[ik];
                        else diff=(prox[ik]+prox[jk])-prox[ij];

                        if (diff<min) min=diff;
                    }
                }
            }


            addconstant=-min;
            if ((addconstant<=0)) 
                writeln("triangle inequality already satisfied");
            for(ij = 0 ; ij< numprox;ij++ ) prox[ij]=prox[ij]+addconstant;
            



        }//(* procedure chkmetric *)

        //(************************************************************************)
        //(* makeroot: make a fake Node, rootnode, with the last two nodes as its *)
        //(*           children.  This Node is of degree two.                     *)
        //(************************************************************************)
        private void makeroot(){ //(* when n=2 *)
            int i=0;
            rootd=d[1];
            numnode=numnode+1;
            rootnode=numnode;
            parent[rootnode]=0;
            length[rootnode]=0.0;
            leafcount[rootnode]=numobject;
            branchset[rootnode]=0;
        
            for(i=0; i<2;i++ ){
                parent[index[i]]=rootnode;
                branchset[rootnode]=branchset[rootnode]+branchset[index[i]];
            }
            if (nodeposition[index[2]]<nodeposition[index[1]]){
                child[rootnode,2]=index[1]; child[rootnode,1]=index[2];
            }else{
                child[rootnode,1]=index[1]; child[rootnode,2]=index[2];
            }
            rootarclength=rootd-height[child[rootnode,1]]-height[child[rootnode,2]];
            if (rootarclength<0.0) {rootarclength=0.0;}
        } // (* makeroot *)

        private void hangroot(){ //(* hang root at correct point on root arc *)
            diff=height[child[rootnode,1]]-height[child[rootnode,2]];
            if (diff>rootarclength) {diff=rootarclength;}
            if (diff<-rootarclength) {diff=-rootarclength;}

            length[child[rootnode,1]]=(rootarclength-diff)/2.0;
            length[child[rootnode,2]]=(rootarclength+diff)/2.0;
            sum1=height[child[rootnode,1]]+length[child[rootnode,1]];
            sum2=height[child[rootnode,2]]+length[child[rootnode,2]];
            height[rootnode] = ((sum1*leafcount[child[rootnode,1]]) + (sum2 * leafcount[child[rootnode,2]])) / leafcount[rootnode];
            leafss[rootnode] = leafss[child[rootnode,1]] + leafss[child[rootnode,2]]
                                + leafcount[child[rootnode,1]] * Math.Sqrt(height[rootnode] - sum1)
                                + leafcount[child[rootnode,2]] * Math.Sqrt(height[rootnode] - sum2);
            if (rooting == rootingtype.minvar)
            {
                writeln("");
                writeln("var. of dis. from root to leaves =" + leafss[rootnode]);
            }
        }// (* hangroot *)

        //(************************************************************************)
        //(* initialize: initialize variables                                     *)
        //(************************************************************************)
        private void initialize(){
            int i, ij;
            n=numobject;
            size=numprox;
            numnode=numobject;
            for(i=0;i<numobject ;i++){
                use[i]=true;
                index[i]=i;
                height[i]=0.0;
                branchset[i]=i;
                leafcount[i]=1; // ver isto com atenção 
                leafss[i]=0.0;
                nodeposition[i]=i;
            }
            for(i=(numobject+1);i<twiceobject ;i++ ){
                height[i]=0.0;
                branchset[i]=0;
                leafcount[i]=0;
                leafss[i]=0.0;
            }
            for(ij=0;ij<numprox ;ij++ ){d[ij]=prox[ij];}

        }//(* initialize *)

        //(************************************************************************)
        //(* findgroups: check all triples, find MNN pairs using T scores:"tscore"*)
        //(************************************************************************)
        private void findgroups(){
            int  i,j,k,ij,ik,jk,xxij,xxjk;
            int[] nn = new int[n] ;
            double t1,t2,t3,loserscore,maxscore,holdi,holdj;
            double[] rowsum = new double[n];
            double[] tscore = new double[size];

          

            //(* findgroups *)
            //(*  check every triple of objects (i,j,k) to find     *)
            //(*  out if (i,j) or (i,k) or (j,k) are neighbors      *)
            for (ij = 0; ij < size; ij++) { tscore[ij] = 0.0; }
            for (i = 0; i < n; i++) { rowsum[i] = 0.0; }
            ij=-1;         
        
            for(i=1;i<n;i++)
                for (j=0;j<(i);j++){
                    ij=ij+1;
                    rowsum[i]=rowsum[i]+d[ij];
                    rowsum[j]=rowsum[j]+d[ij];
                }

            //(* check all triples of objects to see which pair is closest *)
            xxij = 0;// xxij=1;

            for(i=0;i < (n-2);i++){
                xxij = xxij + i;//xxij=xxij+i-1;
                ij=xxij;
                xxjk=xxij;

                for(j=(i+1);j < (n-1);j++){
                    ij = ij + (j - 1); //ij=ij+(j-2);
                    ik=ij;
                    xxjk = xxjk + j;// xxjk = xxjk + j - 1;
                    jk=xxjk;

                    for(k=(j+1);k < n;k++){
                        ik = ik + (k - 1);// ik=ik+(k-2);
                        jk = jk + (k - 1);// jk=jk+(k-2);

                        t1 = rowsum[j] - rowsum[k] + (n - 2) * (d[ik] - d[ij]);
                        t2 = rowsum[i] - rowsum[j] + (n - 2) * (d[jk] - d[ik]);
                        t3 = rowsum[k] - rowsum[i] + (n - 2) * (d[ij] - d[jk]);
                        tscore[ij] = tscore[ij] + t1 - t3;
                        tscore[ik] = tscore[ik] + t2 - t1;
                        tscore[jk] = tscore[jk] + t3 - t2;

                    }// (* k *)
                }// (* j *)                     
            }//  (* i *)

            for(i=0;i<n;i++){ rowsum[i]=0.0; nn[i]=0; }

            ij=-1; // alterei
            loserscore=0.0; 
            maxscore=0.0; 
            holdi=0.0; 
            holdj=0.0;

            //(* re-use array "rowsum" to hold MAX entry of each row of T matrix *)
            //(* use this to find nearest neighbor (nn) of each object i *)

            for (i = 1; i < (n+1); i++)
            {
                int aa = i - 1;
                for (j = 0; j < (aa) ; j++)
                {
                    ij = ij + 1;
                    //(* "loserscore"= max T score in matrix dominated by another score in row
                    //or column.   "rowsum" holds max T score for object i *)
                    if (tscore[ij] > loserscore)
                    {
                        if (tscore[ij] > rowsum[aa])
                        {
                            holdi = rowsum[aa]; rowsum[aa] = tscore[ij]; nn[aa] = j;
                        }
                        else { loserscore = tscore[ij]; }
                        if (tscore[ij] > rowsum[j])
                        {
                            holdj = rowsum[j]; rowsum[j] = tscore[ij]; nn[j] = aa;
                        }
                        else { loserscore = tscore[ij]; }
                        if (loserscore < holdi) { loserscore = holdi; }
                        if (loserscore < holdj) { loserscore = holdj; }
                    }
                    //(* also save max score in entire matrix *)
                    if (maxscore < tscore[ij]) { maxscore = tscore[ij]; }
                }
            }

            //(* now make groups from mutual-nearest-neighbor pairs *)

            numgroup=-1;

            for (i = 1; i < (n+1); i++)
            {
                int aa = (i - 1);
                for (j = 0; j < (aa); j++)
                    if (((nn[aa] == j) && (nn[j] == aa)) && (rowsum[aa] > loserscore))
                    { numgroup = numgroup + 1; group[numgroup, 0] = nn[aa]; group[numgroup, 1] = nn[j]; }
            }
            if (numgroup==0){
                writeln(""); writeln("warning: no MNN pairs in T matrix (Ni = ',"+n+",')");
                numgroup = 1; group[0,0] = nn[1]; group[0,1] =nn[2];
            }

       
        } //  (* findgroups *)

        //(*************************************************************************)
        //(* makenode: using list of groups from "findgroups", make new nodes from *)
        //(*           groups.  Compute Length of arcs between new Node and its    *)
        //(*           children, and define distances from new Node as weighted    *)
        //(*           average of distances from children.                         *)
        //(*************************************************************************)
        private void makenode(){
            int  i,j,k,ij,node,holdcount,sumcount;
            int [] nodegroup= new int[2];

            numnode=numnode+1;
            node = numnode;
            k = 0;

            for(i=0;i<n;i++)
                if (i == group[whichgroup, 0] || i == group[whichgroup, 1])
                {
                    k=k+1;
                    use[i]=false;
                    parent[index[i]]=node;
                    nodegroup[k]=i;
                }


            if(k!=2)
                writeln("error: wrong number of children: Node"+ node);

            for(i=0; i< k ;i++) {
                leafcount[node] = leafcount[node] + leafcount[index[nodegroup[i]]];
                branchset[node] = branchset[node] + branchset[index[nodegroup[i]]];
            }
   
            //(* order children according to specified or input order *)
            if (nodeposition[index[nodegroup[1]]]<nodeposition[index[nodegroup[0]]]){
                child[node,0] = index[nodegroup[1]]; 
                child[node,1] = index[nodegroup[0]];
            }
            else { 
                child[node,0] = index[nodegroup[0]]; 
                child[node,1] = index[nodegroup[1]];
            }
   
            estimate(nodegroup);


            //(* calculate mean Length of leaves under Node ("height") *)
            sum1 = height[child[node,0]] + length[child[node,0]];
            sum2 = height[child[node,1]] + length[child[node,1]];
            height[node] = ((sum1 * leafcount[child[node,0]])
                           +(sum2 * leafcount[child[node,1]])) / leafcount[node];

            //(* calculate sum of squares due to leaf-Length for later choosing of root *)
            leafss[node] = leafss[child[node,0]] + leafss[child[node,1]]
                         + leafcount[child[node,0]] * Math.Sqrt(height[node] - sum1)
                         + leafcount[child[node,1]] * Math.Sqrt(height[node] - sum2);

            //(* calculate average y-position of Node for printing *)
            nodeposition[node] = (nodeposition[child[node,0]] * leafcount[child[node,0]]
                               + nodeposition[child[node,1]] * leafcount[child[node,1]])
                               / leafcount[node];

            //(* recompute distances to other nodes *)
           for(i=0;i<(n+1) ;i++)
               if (use[i]){
                  sumcount = 0; sum = 0.0;
                  for(j=0;j<2;j++){
                    ij = ijfunction(i,nodegroup[j]);
                    holdcount = leafcount[index[nodegroup[j]]] * leafcount[index[i]];
                    sum = sum + holdcount * d[ij];
                    sumcount = sumcount + holdcount;
                  }
                  ij = ijfunction(i,nodegroup[0]);
                  d[ij] = sum / sumcount;
               }
           
           
           use[nodegroup[0]] = true;
           index[nodegroup[0]] = node;
           nreduce = nreduce+1;


        }// (* makenode *)

        private void estimate(int[] nodegroup)
        {//   (* compute arc lengths *)
            double[] sum = new double[2], avedis = new double[2], difff = new double[2];
            double dis,avelength;
            int i,j,holdcount;

            ij=ijfunction(nodegroup[0],nodegroup[1]);
            dis=d[ij];
            for(i=0;i<2;i++){
                holdcount=0; sum[i]=0.0;
                for(j=0; j< (n+1) ;j++) {
                    if (use[j]){
                        ij = ijfunction(nodegroup[i],j);
                        sum[i] = sum[i] + leafcount[index[j]] * d[ij];
                        holdcount = holdcount + leafcount[index[j]];
                    }
                }
                avedis[i] = sum[i] / holdcount;
            }

            avelength =(avedis[0] + avedis[1]) / 2;
            for(i=0;i<2;i++){
                difff[i]=avedis[i]-avelength;
                length[index[nodegroup[i]]] = dis / 2 + difff[i]-height[index[nodegroup[i]]];
                if (length[index[nodegroup[i]]]<0.0) length[index[nodegroup[i]]]=0.0;
            }
        }//(* estimate *)

        //(************************************************************************)
        //(* cleanup: collapse d matrix & prepare for next iteration              *)
        //(************************************************************************)
        private void cleanup(){
            int i,j,k,ij,nij;
            //(* repack d matrix *)
            ij = 0; nij = 0;
            for(j=1;j < n;j++)
                for(i=0;i<(j-1);j++){
                    ij = ij+1;
                    if((use[i]) && (use[j])){
                        nij = nij + 1;
                        d[nij] = d[ij];
                    }
                }

            for(i = (n-1);i < 0;i--)
                if (use[i]==false)
                    for(k=i;k<(n-1);k++)
                        index[k] = index[k + 1];

            n = n - nreduce;
            size = (n * ( n - 1 )) / 2;

        }// (* cleanup *)

       
        
        //(************************************************************************)
        //(* findbestroot: find optimal rooting of the tree                       *)
        //(*               (for rooting=minvar or rooting=specified)              *)
        //(************************************************************************)
        private void findbestroot(){

            double parentlength,parentheight,parentss,minscore;
            
            int ch1,ch2;
            bool foundroot;

            foundroot = false;
            if (rooting == rootingtype.specified) score[rootnode] = 0.0;
            else if (rooting == rootingtype.minvar) score[rootnode] = leafss[rootnode];
            do {

                minscore = score[rootnode];
                parentlength = rootarclength;
                ch1 = child[rootnode,1];
                ch2 = child[rootnode,2];

                parentcount = leafcount[ch2];
                parentheight = height[ch2];
                parentss = leafss[ch2];

                checkchild(ch1,ch2,child[ch1,1],child[ch1,2]);
                checkchild(ch1,ch2,child[ch1,2],child[ch1,1]);

                parentcount = leafcount[ch1];
                parentheight = height[ch1];
                parentss = leafss[ch1];

                checkchild(ch2,ch1,child[ch2,1],child[ch2,2]);
                checkchild(ch2,ch1,child[ch2,2],child[ch2,1]);

                if (minscore>=score[rootnode])
                    foundroot = true;
                else changeroot(goodnode,badnode,goodchild,badchild);

            }while(foundroot);

        }// (* findbestroot *)
        private void changeroot(int gp, int bp, int nde,int othernde){
        
            writeln("changeroot("+ gp +" =>"+ nde + ")");
            parent[nde] = rootnode;
            parent[bp] = gp;
            length[bp] = rootarclength;
            branchset[gp] = branchset[bp] + branchset[othernde];
            leafcount[gp] = leafcount[bp] + leafcount[othernde];
            height[gp] = ((leafcount[bp] * (height[bp] + length[bp]))
                       +(leafcount[othernde] * (height[othernde] + length[othernde]))) / leafcount[gp];
            othersum = height[bp] + rootarclength;
            bsum = height[othernde] + length[othernde];
            leafss[gp] = leafss[bp] + leafss[othernde]
                       + (leafcount[bp] * Math.Sqrt(othersum-height[gp]))
                       + (leafcount[othernde] * Math.Sqrt(bsum-height[gp]));
            nodeposition[gp] = ((leafcount[bp]*nodeposition[bp]) + (leafcount[othernde] * nodeposition[othernde])) / leafcount[gp];
            if (nodeposition[gp]<nodeposition[nde]){
                child[rootnode,1] = gp; child[rootnode,2] = nde;
            }else{ 
                child[rootnode,1] = nde; child[rootnode,2] = gp;
            }
            if (nodeposition[bp]<nodeposition[othernde]){
                child[gp,1] = bp; child[gp,2] = othernde;
            }else{
                child[gp,1] = othernde; child[gp,2] = bp;
            }
            if (rooting== rootingtype.minvar){
                score[gp] = score[rootnode];
                score[rootnode] = score[nde];
            }else{ //  (* if (rooting=specified) *)
                score[gp] = 0.0;
                score[rootnode] = 0.0;
            }
            rootarclength   = length[nde];
        }// (* changeroot *)
        private void checkchild(int gp,int bp,int nde,int othernde)
        {
                    
            if ((nde>0) && (othernde>0)){
                if (rooting == rootingtype.specified)
                    if ((branchset[rootchild[1]] * branchset[nde]!=0) && (branchset[rootchild[2]] * branchset[nde]!=0))
                        score[nde]=-1.0;
                    else 
                        score[nde]=0.0;

                if (rooting == rootingtype.minvar)
                {
                    psum = parentheight+parentlength;
                    othersum = height[othernde]+length[othernde];
                    newparentcount = parentcount+leafcount[othernde];
                    newparentheight = ((psum*parentcount) + (othersum*leafcount[othernde])) / newparentcount;
                    newparentss = parentss + leafss[othernde] 
                                + (parentcount * Math.Sqrt(psum - newparentheight))
                                + (leafcount[othernde] * Math.Sqrt(othersum - newparentheight));

                    diff = height[nde] - newparentheight;
                    if (diff>length[nde]) diff = length[nde];
                    if (diff<-length[nde]) diff = -length[nde];

                    foo1 = (length[nde] - diff)/2.0;
                    foo2 = (length[nde] + diff)/2.0;
                    sum1 = height[nde] + foo1;
                    sum2 = newparentheight + foo2;
                    fooheight = ((sum1 * leafcount[nde]) + (sum2 * newparentcount)) / numobject;
                    score[nde] = leafss[nde] + newparentss
                               + leafcount[nde] * Math.Sqrt(fooheight - sum1)
                               + newparentcount * Math.Sqrt(fooheight - sum2);
                    writeln("Node"+ nde + "  score=" + score[nde]);
                }// (* minvar section *)

                if (score[nde]<minscore){
                    minscore = score[nde];
                    goodnode = gp; badnode = bp; goodchild = nde; badchild = othernde;
                }
            }
        } //(* checkchild *)



        //(************************************************************************)
        //(* report: write tree structure and arc-Length estimates; draw tree     *)
        //(************************************************************************)
        private void report(){
            int i,j;
            writeln(""); writeln(""); writeln("");
            writeln(""); writeln("Node     Length    children");
            for(i=0;i<numnode;i++){

            write( i + "    ");
            write(length[i] + "     ");
            if (i<=numobject) 
            {
                write("                  ");
                /*for(j=0;j<20;j++)*/ write(name[i]);
            }
            else for(j=0;j<2;j++) write((char)child[i,j]);
            writeln("");
            }
            writeln(""); writeln(""); writeln(""); writeln("");


    }

      /*(* descend calculates:       
      vertical position of a branch ("yposition")
      horizontal position of branch ("height") 
      endpoints of vertical connecting lines ("topkid","bottomkid")  *)*/
        private void descend(int nde){
            int i=0;

            if (nde!=rootnode){ height[nde] = height[parent[nde]] + length[nde];}
      
            if (nde<=numobject){//            (* if nde is a leaf *)
                numleaf = numleaf+1;
                yposition[nde] = (numleaf * 2) - 1;
            }
            else{//                (* if nde is an interior Node *)
                for(i=0;i<2;i++){
                    descend(child[nde,i]);
                    yposition[nde] = yposition[nde] + (yposition[child[nde,i]]*leafcount[child[nde,i]]);
                }
                yposition[nde] = yposition[nde] / leafcount[nde];
                topkid[nde] = yposition[child[nde,1]];
                bottomkid[nde] = yposition[child[nde,2]];
            }

        } //(* descend *)


        private void drawtree(){//  (* drawtree *)
            const char vertchar = '|';  
            const char horizchar = '-';
            int i,x,y;

            height[rootnode] = 0.0; numleaf = 0;
            for(i=(numobject+1);i < numnode;i++ ) yposition[i] = 0;

            descend(rootnode);

            if (numobject != numleaf)
                writeln("error in descend, numleaf=" + numleaf);
            
            maxheight = 0.0;
            for(i=0;i<numobject ;i++)
                if (height[i]>maxheight) maxheight = height[i];
            
            stretch = (linesize-namelength-8)/maxheight;


            //(* write tree arcs (horizontal lines) *)
            for(y=0;y<(2*numobject) ;y++)
            {
                maxstop = 0;
                for(i=0;i< linesize ;i++) line[i] = ' ';
                for(node = 1; node< numnode ;node++ ) {
                    if (yposition[node]==y) {
                        if (parent[node] != 0) 
                            start = (int)(stretch * height[parent[node]]) + 1;
                        else start = 1;
                            stop = (int)(stretch * height[node]) + 1;
                        if (stop > maxstop) maxstop = stop;
                        if (stop > linesize) stop  = linesize;
                        for (x = start;x < stop; x++ ) line[x] = horizchar;
                    }

                    //(* place vertical conecting lines *)
                    if (node > numobject)
                        if ((y > topkid[node]) && (y < bottomkid[node])){
                            stop = (int)(stretch * height[node]) + 1;
                            if ( stop > maxstop) 
                                maxstop = stop;
                            line[stop] = vertchar;
                        }

                }// (* loop on Node *)

            for(i=0;i< maxstop ;i++) 
                write(line[i]);
            for(i=0;i< numobject;i++)
                if (yposition[i]==y) {
                    if (printnumbers)
                        write(i+"  ");
                    else write("  ");
                    /*for(j=0;j<namelength;j++)*/
                        write(name[i]);
                }
              writeln(outfile);
            }

        }// (* drawtree *)


        public Gtree(ArrayList listaNomes_, ArrayList listaDados_ ,String path)
        {

            listaNomes = listaNomes_;
            listaDados = listaDados_;
            tw = new StreamWriter(path);
            {   /* start Iniciação de variaveis */
                // bool
                use = new bool[maxobject];
                // int []
                parent = new int[twiceobject];
                leafcount = new int[twiceobject];
                grouptype = new int[maxobject];
                branchset = new int[twiceobject];
                index = new int[maxobject];
                group = new int[maxobject, maxobject];
                rootchild = new int[2];
                // int [,]
                child = new int[twiceobject, 2];
                group = new int[maxobject, maxobject];
                // double[]
                prox = new double[maxsize];
                d = new double[maxsize];
                length = new double[twiceobject];
                nodeposition = new double[twiceobject];
                height = new double[twiceobject];
                leafss = new double[twiceobject];
                // string []
                name = new string[maxobject];

                // int 
                ij = 0;
                numobject = 0;
                feed = 0;
                numprox = 0;
                numnode = 0;
                rootnode = 0;
                size = 0;
                n = 0;
                numgroup = 0;
                whichgroup = 0;
                nreduce = 0;
                linesize = 0;
                namelength = 0;
                //double
                addconstant = 0;
                maxdis = 0;
                rootd = 0;
                rootarclength = 0;
                diff = 0;
                sum = 0;
                sum1 = 0;
                sum2 = 0;

                //*********************************************
                // findbestroot
                score = new double[twiceobject];
                psum = 0;
                parentheight = 0;
                parentlength = 0; othersum = 0;
                newparentcount = 0; parentcount = 0;
                newparentheight = 0; newparentss = 0;
                foo1 = 0; foo2 = 0; parentss = 0;
                fooheight = 0; minscore = 0; bsum = 0;
                goodnode = 0; badnode = 0; goodchild = 0; badchild = 0;
                //*********************************************
                // report
                start = 0; stop = 0; maxstop = 0; node=0;
                maxheight = 0; stretch = 0;
                line = new char[linelength];
                yposition = new int[twiceobject]; topkid = new int[twiceobject]; bottomkid = new int[twiceobject];
                numleaf = 0;

            }/* end Iniciação de variaveis */

            { /* aqui carregos os meus dados para a estruturas da gtree */

              
               
                
                
                linesize=linelength; 
                rooting= rootingtype.asis; 

                
                for (int ka = 0; ka < listaNomes.Count; ka++)
                    name[ka] = listaNomes[ka].ToString();
                int contador=0;
                for (int ka = 0; ka < ListaDados.Count; ka++)
                    for (int kb = 0; kb < ((ArrayList)ListaDados[ka]).Count; kb++) {
                        prox[contador] = (double)((ArrayList)ListaDados[ka])[kb];
                        contador++;
                    }

                numobject = listaNomes.Count;
            } /* aqui carregos os meus dados para a estruturas da gtree */
            int aux=0;
            for (aux = 0; aux < prox.Length; aux++)
                if (prox[aux] == 0.0)
                   break;
            numprox=aux;

            chkmetric();
            initialize();

            
        //(* main clustering loop **********************************)
           while (n>=4){

              numgroup = 0; nreduce = 0;
              findgroups();

              for(int i=0;i< n ;i++) use[i] = true;
              for(whichgroup=0;whichgroup<numgroup; whichgroup++) makenode();

              cleanup();

           }
        
        //(* end main clustering loop ******************************)
        //(* choose a root for the tree (now there are n=3 or n=2 nodes left) *)
            if (n==3){
                numgroup=1; whichgroup=1;
                if ((height[index[1]]>height[index[2]]) && (height[index[1]]>height[index[3]]))
                    group[whichgroup, 1] = group[whichgroup, 2] + group[whichgroup,3];
                else if ((height[index[2]]>height[index[1]]) && (height[index[2]]>height[index[3]]))
                    group[whichgroup, 1] = group[whichgroup, 1] + group[whichgroup,3];
                else
                    group[whichgroup, 1] = group[whichgroup, 1] + group[whichgroup,2];
                for(int ka=0;ka<3;ka++) use[ka]=true;
                
                makenode();
                cleanup();  
            }
        //(* now n=2 *)
            makeroot();
            hangroot();
            if (rooting != rootingtype.asis){
                findbestroot();//   (* specified rooting or minvarroot *)
                hangroot();
            }
        //(* end root-choosing section *)
            //  */
            report();



            tw.Close();
        }

        private void writeln(String texto)
        {
            tw.WriteLine(texto);
        }
        private void write(char ch){
            tw.Write(ch);
        }private void write(string ch){
            tw.Write(ch);
        }

        public Gtree(String path){
            tw = new StreamWriter(path);
        }

        public ArrayList ListaNomes
        {
            get { return listaNomes; }
            set { listaNomes = value; }
        }
        public ArrayList ListaDados
        {
            get { return listaDados; }
            set { listaDados = value; }
        }
    }
}
