﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.IO;
using System.Collections;
using System.Text;

namespace MFCalculator
{

    /* Local variables for makenode: */
    struct LOC_makenode
    {
        public long ij;
        public long[] nodegroup;// = new long[2];   /* holds pair being made into Node */
    };
    /* Local variables for findbestroot: */
    struct LOC_findbestroot
    {
        public double parentlength, parentheight, parentss, minscore, psum, bsum, othersum, fooheight, newparentheight, newparentss, foo1, foo2;
        public double[] score;     //[twiceobject]
        public long parentcount, newparentcount, goodnode, badnode, goodchild, badchild;
    };
    /* Local variables for drawtree: */
    struct LOC_drawtree
    {
        public long[] yposition; // [twiceobject];
        public long[] topkid, bottomkid; //[twiceobject];
        public long numleaf;
    };
    /* Local variables for stats: */
    struct LOC_stats
    {
        public double[] modeldis;  //[maxsize]
        public long[] c;           //[maxsize];
    } ;


    public class Tree
    {
        private String treeGrafic = "";
        private ArrayList listaDados;
        private ArrayList listaNomes;
        private ArrayList listaResult;

        public ArrayList ListaResult
        {
            get { return listaResult; }
            set { listaResult = value; }
        }


        #region Variaveis
        const char vertchar = '|';   /* change if desired */
        const char horizchar = '-';

        const int maxobject = 3200;
        const int twiceobject = maxobject * 2;                  // 160
        const int maxsize = (maxobject / 2) * (maxobject - 1);  // 3160;
        const int linelength = 80;
        enum rootingtype { asis, minvar, specified }

        double[] prox = new double[maxsize];   /* input proximities */
        double[] d = new double[twiceobject];   /* transformed data distances */
        long numobject;   /* number of objects */
        long numprox;   /* number of inter-object distances */
        long n;   /* number of nodes at current iteration */
        long size;   /* number of distances at this iteration */
        bool similarities;
        /* similarity or distance data; lowerhalf or full matrix */
        double proxcode;   /* 1.0 if distances, -1.0 if sim. */
        double addconstant;
        /* additive constant for positivity and triangle inequality */
        double diff, maxdis, sum, sum1, sum2;
        long x, y, hold, int_, whichgroup;
        long[,] group = new long[maxobject, maxobject];
        /* pairs of objects to be joined at current iteration */
        long numgroup, nreduce;   /* number of such pairs */
        long numnode, rootnode;
        /* number of nodes in tree; number of root Node */
        double[] parent = new double[twiceobject];   /* "parent" of a Node */
        double[,] child = new double[twiceobject, 2];   /* "children" of Node */
        double[] length_ = new double[twiceobject];   /* Length of arc between a Node and its parent */
        double[] height = new double[twiceobject];   /* height (average Length) of Node in tree */
        double[] leafcount = new double[twiceobject];
        /* number of objects in the branch determined by Node */
        double[,] branchset = new double[twiceobject, twiceobject];
        /* keeps track of objects in each branch */
        double[] index_ = new double[maxobject];
        /* keeps track of true Node number as d matrix collapses */
        bool[] use = new bool[maxobject];
        /* keeps track of pairs being combined on this step */
        double rootarclength, rootd;   /* Length of arc root is on */
        long[] leafss = new long[twiceobject];
        /* holds sums-of-squares due to leaf-Length for a Node */
        string[] name = new string[maxobject];   /* object names */
        long namelength = 0;   /* Length of longest Name */
        bool subtractconstant;
        /* if triang. ineq. already satisfied, subtract a constant
           so that it is exactly satisfied? */
        rootingtype rooting;
        /* three options are available for selection of
                                 root:  asis=just put root at last two nodes
                                        minvar=find root with min. variance of
                                               root-to-leaf distances
                                        specified=root at specified nodes */
        long[] rootchild = new long[2];   /* for specified rooting */
        bool printnumbers = false, specifyorder = false;
        /* output options requests */
        long linesize;   /* output linelength for crt, etc. */
        double[] nodeposition = new double[twiceobject];   /* hold calculated y-position of tree nodes*/
        // Acrescentos 
        //TextWriter tw;

        #endregion
        #region ijfunction
        /************************************************************************/
        /* ijfunction: converts the row and column of a lowerhalf matrix        */
        /* to the ordinal position of that entry in a vector (matrixarray)      */
        /************************************************************************/
        long ijfunction(long i, long j)
        {
            long result = 0;
            if (i > j)
                result = ((i - 1) * (i - 2) / 2 + j);
            if (j > i)
                result = ((j - 1) * (j - 2) / 2 + i);
            return result;
            //printf("error: i=j in ijfunction\n");
        }  /* ijfunction */
        #endregion
        #region chkmetric
        /*************************************************************************/
        /* chkmetric: check if proximities satisfy metric axioms, fix if not     */
        /*************************************************************************/
        void chkmetric()
        {
            long i, j, k, ij, ik, jk;
            long xxij = 1;
            long xxjk;
            double diff;
            double min = 0.0;
            long FORLIM, FORLIM1, FORLIM2;

            addconstant = 0.0;
            maxdis = 0.0;

            /* convert to dissimilarities if necessary */
            if (similarities)
            {
                proxcode = -1.0;
                fprintf("similarities linearly transformed into distances\n");
            }
            else
                proxcode = 1.0;


            FORLIM = numprox;

            /* check for positivity of distances */
            for (ij = 0; ij < FORLIM; ij++)
            {
                prox[ij] = proxcode * prox[ij];
                if (prox[ij] < min)
                    min = prox[ij];
                if (prox[ij] > maxdis)
                    maxdis = prox[ij];
            }
            if (min < 0.0)
                addconstant = -min;
            fprintf("(" + addconstant + "  needed for positivity of distances )");

            /* check every triple of objects for triangle inequality */
            min = maxdis;
            FORLIM = numobject - 2;
            for (i = 1; i <= FORLIM; i++)
            {
                xxij += i - 1;
                ij = xxij;
                xxjk = xxij;
                FORLIM1 = numobject;
                for (j = i + 1; j < FORLIM1; j++)
                {
                    ij += j - 2;
                    ik = ij;
                    xxjk += j - 1;
                    jk = xxjk;
                    FORLIM2 = numobject - 2;
                    for (k = j - 1; k <= FORLIM2; k++)
                    {
                        ik += k;
                        jk += k;
                        if (prox[jk - 1] >= prox[ij - 1] && prox[jk - 1] >= prox[ik - 1])
                            diff = prox[ij - 1] + prox[ik - 1] - prox[jk - 1];
                        else if (prox[ik - 1] >= prox[ij - 1] && prox[ik - 1] >= prox[jk - 1])
                            diff = prox[ij - 1] + prox[jk - 1] - prox[ik - 1];
                        else
                            diff = prox[ik - 1] + prox[jk - 1] - prox[ij - 1];
                        if (diff < min)
                            min = diff;
                    }
                }
            }
            addconstant = -min;
            if (subtractconstant == false && addconstant <= 0)
                fprintf("triangle inequality already satisfied\n");
            else
            {
                fprintf(" " + addconstant + "  added to exactly satisfy triangle inequality\n");
                FORLIM = numprox;
                for (ij = 0; ij < FORLIM; ij++)
                    prox[ij] += addconstant;
            }

            //fprintf(outfile, "\n\n");
        }  /* chkmetric */
        #endregion
        #region initialize
        /************************************************************************/
        /* initialize: initialize variables                                     */
        /************************************************************************/
        void initialize()
        {
            long i, ij, FORLIM;

            n = numobject;
            size = numprox;
            numnode = numobject;
            FORLIM = numobject;
            for (i = 1; i <= FORLIM; i++)
            {
                use[i - 1] = true;
                index_[i - 1] = i;
                height[i - 1] = (long)0.0;
                branchset[i - 1, 0] = i;
                leafcount[i - 1] = 1;
                leafss[i - 1] = (long)0.0;
                if (!specifyorder)
                    nodeposition[i - 1] = i;
            }
            for (i = numobject; i < twiceobject; i++)
            {
                height[i] = (long)0.0;
                branchset[i, 0] = 0L;
                leafcount[i] = 0;
                leafss[i] = (long)0.0;
            }
            FORLIM = numprox;
            for (ij = 0; ij < FORLIM; ij++)
                d[ij] = prox[ij];
        }  /* initialize */
        #endregion
        #region findgroups
        /************************************************************************/
        /* findgroups: check all triples, find MNN pairs using T scores:"tscore"*/
        /************************************************************************/
        void findgroups()
        {
            long i, j, k, ij, ik, jk;
            long xxij = 1;
            long xxjk;
            double t1, t2, t3;
            double loserscore = 0.0, maxscore = 0.0, holdi = 0.0, holdj = 0.0;
            double[] rowsum = new double[maxobject];
            double[] tscore = new double[maxsize];
            long[] nn = new long[maxobject];
            long FORLIM, FORLIM1, FORLIM2;
            long[] SET = new long[4];
            long[] SET1 = new long[4];


            FORLIM = size;
            /*  check every triple of objects (i,j,k) to find     */
            /*  out if (i,j) or (i,k) or (j,k) are neighbors      */
            for (ij = 0; ij < FORLIM; ij++)
                tscore[ij] = 0.0;
            FORLIM = n;
            /* calculate sum of dissimilarities for each object */
            for (i = 0; i < FORLIM; i++)
                rowsum[i] = 0.0;
            ij = 0;
            FORLIM = n;
            for (i = 2; i <= FORLIM; i++)
            {
                for (j = 0; j <= i - 2; j++)
                {
                    ij++;
                    rowsum[i - 1] += d[ij - 1];
                    rowsum[j] += d[ij - 1];
                }
            }

            FORLIM = n - 2;
            /* check all triples of objects to see which pair is closest */
            for (i = 1; i <= FORLIM; i++)
            {
                xxij += i - 1;
                ij = xxij;
                xxjk = xxij;

                FORLIM1 = n;
                for (j = i + 1; j < FORLIM1; j++)
                {
                    ij += j - 2;
                    ik = ij;
                    xxjk += j - 1;
                    jk = xxjk;

                    FORLIM2 = n;
                    for (k = j + 1; k <= FORLIM2; k++)
                    {
                        ik += k - 2;
                        jk += k - 2;

                        t1 = rowsum[j - 1] - rowsum[k - 1] + (n - 2) * (d[ik - 1] - d[ij - 1]);
                        t2 = rowsum[i - 1] - rowsum[j - 1] + (n - 2) * (d[jk - 1] - d[ik - 1]);
                        t3 = rowsum[k - 1] - rowsum[i - 1] + (n - 2) * (d[ij - 1] - d[jk - 1]);
                        tscore[ij - 1] += t1 - t3;
                        tscore[ik - 1] += t2 - t1;
                        tscore[jk - 1] += t3 - t2;

                    }  /* k */
                }  /* j */
            }  /* i */

            FORLIM = n;
            /* re-use array "rowsum" to hold MAX entry of each row of T matrix */
            /* use this to find nearest neighbor (nn) of each object i */
            for (i = 0; i < FORLIM; i++)
            {
                rowsum[i] = 0.0;
                nn[i] = 0;
            }
            ij = 0;
            FORLIM = n;
            for (i = 2; i <= FORLIM; i++)
            {
                for (j = 0; j <= i - 2; j++)
                {
                    ij++;
                    /* "loserscore"= max T score in matrix dominated by another score in row
                         or column.   "rowsum" holds max T score for object i */
                    if (tscore[ij - 1] > loserscore)
                    {
                        if (tscore[ij - 1] > rowsum[i - 1])
                        {
                            holdi = rowsum[i - 1];
                            rowsum[i - 1] = tscore[ij - 1];
                            nn[i - 1] = j + 1;
                        }
                        else
                            loserscore = tscore[ij - 1];
                        if (tscore[ij - 1] > rowsum[j])
                        {
                            holdj = rowsum[j];
                            rowsum[j] = tscore[ij - 1];
                            nn[j] = i;
                        }
                        else
                            loserscore = tscore[ij - 1];
                        if (loserscore < holdi)
                            loserscore = holdi;
                        if (loserscore < holdj)
                            loserscore = holdj;
                    }
                    /* also save max score in entire matrix */
                    if (maxscore < tscore[ij - 1])
                        maxscore = tscore[ij - 1];
                }
            }

            /* now make groups from mutual-nearest-neighbor pairs */
            numgroup = 0;
            FORLIM = n;
            for (i = 2; i <= FORLIM; i++)
            {
                for (j = 1; j < i; j++)
                {
                    if (nn[i - 1] == j && nn[j - 1] == i && rowsum[i - 1] > loserscore)
                    {
                        group[numgroup, 0] = nn[i - 1];
                        group[numgroup, 1] = nn[j - 1];
                        numgroup++;
                    }
                }
            }

            if (numgroup != 0)
                return;
            //printf("\nwarning: no MNN pairs in T matrix (Ni = %4ld)\n", n);
            numgroup = 1;
            group[0, 0] = nn[1];
            group[0, 1] = nn[2];
        }  /* findgroups */
        #endregion
        #region estimate
        LOC_makenode estimate(LOC_makenode LINK)
        {
            /* compute arc lengths */
            double[] sum = new double[2], avedis = new double[2], diff = new double[2];
            double dis, avelength;
            long i, j, FORLIM1;
            double holdcount;

            LINK.ij = ijfunction(LINK.nodegroup[0], LINK.nodegroup[1]);
            dis = d[LINK.ij - 1];
            for (i = 0; i <= 1; i++)
            {
                holdcount = 0;
                sum[i] = 0.0;
                FORLIM1 = n;
                for (j = 1; j <= FORLIM1; j++)
                {
                    if (use[j - 1])
                    {
                        LINK.ij = ijfunction(LINK.nodegroup[i], j);
                        sum[i] += leafcount[(int)index_[j - 1] - 1] * d[LINK.ij - 1];
                        holdcount += leafcount[(int)index_[j - 1] - 1];
                    }
                }
                avedis[i] = sum[i] / holdcount;
            }

            avelength = (avedis[0] + avedis[1]) / 2;
            for (i = 0; i <= 1; i++)
            {
                diff[i] = avedis[i] - avelength;
                length_[(int)index_[LINK.nodegroup[i] - 1] - 1] = (double)(dis / 2 + diff[i] - height[(int)index_[LINK.nodegroup[i] - 1] - 1]);
                if (length_[(int)index_[LINK.nodegroup[i] - 1] - 1] < 0.0)
                    length_[(int)index_[LINK.nodegroup[i] - 1] - 1] = (long)0.0;
            }
            return LINK;  // Alterado por mim
        }  /* estimate */
        #endregion
        # region makenode
        /*************************************************************************/
        /* makenode: using list of groups from "findgroups", make new nodes from */
        /*           groups.  Compute Length of arcs between new Node and its    */
        /*           children, and define distances from new Node as weighted    */
        /*           average of distances from children.                         */
        /*************************************************************************/
        void makenode()
        {
            LOC_makenode V = new LOC_makenode();
            V.nodegroup = new long[2];
            long i, j;
            long k = 0;
            long node, holdcount, sumcount, FORLIM;
            double TEMP, TEMP1;

            numnode++;
            node = numnode;
            FORLIM = n;
            for (i = 1; i <= FORLIM; i++)
            {
                if ((int)i == group[whichgroup - 1, 0] || (int)i == group[whichgroup - 1, 1])
                {
                    k++;
                    use[i - 1] = false;
                    parent[(int)index_[i - 1] - 1] = node;
                    V.nodegroup[k - 1] = i;
                }
            }
            if (k != 2)
                fprintf("error: wrong number of children: Node%" + node.ToString() + "d\n");

            for (i = 0; i < k; i++)
            {
                leafcount[node - 1] += leafcount[(int)index_[V.nodegroup[i] - 1] - 1];
                branchset[node - 1, 0] = branchset[node - 1, 0] + branchset[(int)index_[V.nodegroup[i] - 1] - 1, 0];
            }


            /* order children according to specified or input order */
            if (nodeposition[(int)index_[V.nodegroup[1] - 1] - 1] <
                nodeposition[(int)index_[V.nodegroup[0] - 1] - 1])
            {
                child[node - 1, 0] = index_[V.nodegroup[1] - 1];
                child[node - 1, 1] = index_[V.nodegroup[0] - 1];
            }
            else
            {
                child[node - 1, 0] = index_[V.nodegroup[0] - 1];
                child[node - 1, 1] = index_[V.nodegroup[1] - 1];
            }


            V = estimate(V);


            /* calculate mean Length of leaves under Node ("height") */
            sum1 = height[(int)child[node - 1, 0] - 1] + length_[(int)child[node - 1, 0] - 1];
            sum2 = height[(int)child[node - 1, 1] - 1] + length_[(int)child[node - 1, 1] - 1];
            height[node - 1] = ((sum1 * leafcount[(int)child[node - 1, 0] - 1] + sum2 * leafcount[(int)child[node - 1, 1] - 1]) / leafcount[node - 1]);

            TEMP = (height[node - 1] - sum1);
            TEMP1 = (height[node - 1] - sum2);
            /* calculate sum of squares due to leaf-Length for later choosing of root */
            leafss[node - 1] = (long)(leafss[(int)child[node - 1, 0] - 1] + leafss[(int)child[node - 1, 1] - 1] +
                     leafcount[(int)child[node - 1, 0] - 1] * (TEMP * TEMP) +
                     leafcount[(int)child[node - 1, 1] - 1] * (TEMP1 * TEMP1));

            /* calculate average y-position of Node for printing */
            nodeposition[node - 1] =
              (nodeposition[(int)child[node - 1, 0] - 1] * leafcount[(int)child[node - 1, 0] - 1] +
               nodeposition[(int)child[node - 1, 1] - 1] * leafcount[(int)child[node - 1, 1] - 1]) /
              leafcount[node - 1];

            FORLIM = n;
            /* recompute distances to other nodes */
            for (i = 1; i <= FORLIM; i++)
            {
                if (use[i - 1])
                {
                    sumcount = 0;
                    sum = 0.0;
                    for (j = 0; j <= 1; j++)
                    {
                        V.ij = ijfunction(i, V.nodegroup[j]);
                        holdcount = (long)(leafcount[(int)index_[V.nodegroup[j] - 1] - 1] * leafcount[(int)index_[i - 1] - 1]);
                        sum += holdcount * d[V.ij - 1];
                        sumcount += holdcount;
                    }
                    V.ij = ijfunction(i, V.nodegroup[0]);
                    d[V.ij - 1] = (sum / sumcount);
                }
            }


            use[V.nodegroup[0] - 1] = true;
            index_[V.nodegroup[0] - 1] = node;
            nreduce++;

            //putchar('.');
        }  /* makenode */
        #endregion
        #region cleanup
        /************************************************************************/
        /* cleanup: collapse d matrix & prepare for next iteration            */
        /************************************************************************/
        void cleanup()
        {
            long i, j, k;
            long ij = 0, nij = 0;
            long FORLIM, FORLIM1;

            /* repack d matrix */
            FORLIM = n;
            for (j = 2; j <= FORLIM; j++)
            {
                for (i = 0; i <= j - 2; i++)
                {
                    ij++;
                    if (use[i] && use[j - 1])
                    {
                        nij++;
                        d[nij - 1] = d[ij - 1];
                    }
                }
            }

            for (i = n - 1; i >= 1; i--)
            {
                if (use[i - 1] == false)
                {
                    FORLIM1 = n;
                    for (k = i; k < FORLIM1; k++)
                        index_[k - 1] = index_[k];
                }
            }

            n -= nreduce;
            size = n * (n - 1) / 2;

        }  /* cleanup */
        #endregion
        #region makeroot
        /************************************************************************/
        /* makeroot: make a fake Node, rootnode, with the last two nodes as its */
        /*           children.  This Node is of degree two.                  */
        /************************************************************************/
        void makeroot()
        {
            /* when n=2 */
            long i;

            rootd = d[0];
            numnode++;
            rootnode = numnode;
            parent[rootnode - 1] = 0;
            length_[rootnode - 1] = 0L;
            leafcount[rootnode - 1] = numobject;
            branchset[rootnode - 1, 0] = 0L;
            for (i = 0; i <= 1; i++)
            {
                parent[(int)index_[i] - 1] = rootnode;
                branchset[rootnode - 1, 0] = branchset[rootnode - 1, 0] + branchset[(int)index_[i] - 1, 0];
            }
            if (nodeposition[(int)index_[1] - 1] < nodeposition[(int)index_[0] - 1])
            {
                child[rootnode - 1, 1] = index_[0];
                child[rootnode - 1, 0] = index_[1];
            }
            else
            {
                child[rootnode - 1, 0] = index_[0];
                child[rootnode - 1, 1] = index_[1];
            }
            rootarclength = rootd - height[(int)child[rootnode - 1, 0] - 1] -
                    height[(int)child[rootnode - 1, 1] - 1];
            if (rootarclength < 0.0)
                rootarclength = 0.0;
        }  /* makeroot */
        #endregion
        #region hangroot
        void hangroot()
        {
            /* hang root at correct point on root arc */
            double TEMP, TEMP1;

            diff = height[(int)child[rootnode - 1, 0] - 1] - height[(int)child[rootnode - 1, 1] - 1];
            if (diff > rootarclength)
                diff = rootarclength;
            if (diff < -rootarclength)
                diff = -rootarclength;
            length_[(int)child[rootnode - 1, 0] - 1] = ((rootarclength - diff) / 2.0);
            length_[(int)child[rootnode - 1, 1] - 1] = ((rootarclength + diff) / 2.0);
            sum1 = height[(int)child[rootnode - 1, 0] - 1] + length_[(int)child[rootnode - 1, 0] - 1];
            sum2 = height[(int)child[rootnode - 1, 1] - 1] + length_[(int)child[rootnode - 1, 1] - 1];
            height[rootnode - 1] = ((sum1 * leafcount[(int)child[rootnode - 1, 0] - 1] +
            sum2 * leafcount[(int)child[rootnode - 1, 1] - 1]) / leafcount[rootnode - 1]);
            TEMP = height[rootnode - 1] - sum1;
            TEMP1 = height[rootnode - 1] - sum2;
            leafss[rootnode - 1] = (long)(leafss[(int)child[rootnode - 1, 0] - 1] +
                         leafss[(int)child[rootnode - 1, 1] - 1] +
                         leafcount[(int)child[rootnode - 1, 0] - 1] * (TEMP * TEMP) +
                         leafcount[(int)child[rootnode - 1, 1] - 1] * (TEMP1 * TEMP1));
            if (rooting == rootingtype.asis)
                fprintf("var. of dis. from root to leaves = " + leafss[rootnode - 1] + " ");
        }  /* hangroot */
        #endregion
        #region checkchild
        LOC_findbestroot checkchild(long gp, long bp, long nde, long othernde, LOC_findbestroot LINK)
        {
            long[,] SET = new long[maxobject, maxobject], SET1 = new long[maxobject, maxobject];
            double TEMP, TEMP1;

            if (nde <= 0 || othernde <= 0)
                return LINK;

            if (rooting == rootingtype.specified)
            {
                if ((branchset[rootchild[0] - 1, 0] * branchset[nde - 1, 0]) != 0 && (branchset[rootchild[1] - 1, 0] * branchset[nde - 1, 0]) != 0)
                    LINK.score[nde - 1] = -1.0;
                else
                    LINK.score[nde - 1] = 0.0;
            }

            if (rooting == rootingtype.minvar)
            {
                LINK.psum = LINK.parentheight + LINK.parentlength;
                LINK.othersum = height[othernde - 1] + length_[othernde - 1];
                LINK.newparentcount = (long)(LINK.parentcount + leafcount[othernde - 1]);
                LINK.newparentheight = (LINK.psum * LINK.parentcount +
                  LINK.othersum * leafcount[othernde - 1]) / LINK.newparentcount;
                TEMP = (LINK.psum - LINK.newparentheight);
                TEMP1 = (LINK.othersum - LINK.newparentheight);
                LINK.newparentss = LINK.parentss + leafss[othernde - 1] +
                        LINK.parentcount * (TEMP * TEMP) +
                        leafcount[othernde - 1] * (TEMP1 * TEMP1);

                diff = height[nde - 1] - LINK.newparentheight;
                if (diff > length_[nde - 1])
                    diff = length_[nde - 1];
                if (diff < -length_[nde - 1])
                    diff = -length_[nde - 1];
                LINK.foo1 = (length_[nde - 1] - diff) / 2.0;
                LINK.foo2 = (length_[nde - 1] + diff) / 2.0;
                sum1 = height[nde - 1] + LINK.foo1;
                sum2 = LINK.newparentheight + LINK.foo2;
                LINK.fooheight =
                  (sum1 * leafcount[nde - 1] + sum2 * LINK.newparentcount) / numobject;
                TEMP = (LINK.fooheight - sum1);
                TEMP1 = (LINK.fooheight - sum2);
                LINK.score[nde - 1] = leafss[nde - 1] + LINK.newparentss +
                         leafcount[nde - 1] * (TEMP * TEMP) +
                         LINK.newparentcount * (TEMP1 * TEMP1);
                fprintf("Node" + nde + "d  score=" + LINK.score[nde - 1] + "\n");

            }  /* minvar section */

            if (LINK.score[nde - 1] >= LINK.minscore)
                return LINK;
            LINK.minscore = LINK.score[nde - 1];
            LINK.goodnode = gp;
            LINK.badnode = bp;
            LINK.goodchild = nde;
            LINK.badchild = othernde;
            return LINK;
        }  /* checkchild */
        #endregion
        #region changeroot
        LOC_findbestroot changeroot(long gp, long bp, long nde, long othernde, LOC_findbestroot LINK)
        {
            double TEMP, TEMP1;

            fprintf("changeroot(" + gp + " =>" + nde + ")\n");
            parent[nde - 1] = rootnode;
            parent[bp - 1] = gp;
            length_[bp - 1] = rootarclength;
            branchset[gp - 1, 0] = branchset[bp - 1, 0] + branchset[othernde - 1, 0];
            leafcount[gp - 1] = leafcount[bp - 1] + leafcount[othernde - 1];
            height[gp - 1] = (leafcount[bp - 1] * (height[bp - 1] + length_[bp - 1]) +
              leafcount[othernde - 1] * (height[othernde - 1] + length_[othernde - 1])) /
                leafcount[gp - 1];
            LINK.othersum = height[bp - 1] + rootarclength;
            LINK.bsum = height[othernde - 1] + length_[othernde - 1];
            TEMP = LINK.othersum - height[gp - 1];
            TEMP1 = LINK.bsum - height[gp - 1];
            leafss[gp - 1] = (long)(leafss[bp - 1] + leafss[othernde - 1] + leafcount[bp - 1] *
                     (TEMP * TEMP) + leafcount[othernde - 1] * (TEMP1 * TEMP1));
            nodeposition[gp - 1] = (leafcount[bp - 1] * nodeposition[bp - 1] +
              leafcount[othernde - 1] * nodeposition[othernde - 1]) / leafcount[gp - 1];
            if (nodeposition[gp - 1] < nodeposition[nde - 1])
            {
                child[rootnode - 1, 0] = gp;
                child[rootnode - 1, 1] = nde;
            }
            else
            {
                child[rootnode - 1, 0] = nde;
                child[rootnode - 1, 1] = gp;
            }
            if (nodeposition[bp - 1] < nodeposition[othernde - 1])
            {
                child[gp - 1, 0] = bp;
                child[gp - 1, 1] = othernde;
            }
            else
            {
                child[gp - 1, 0] = othernde;
                child[gp - 1, 1] = bp;
            }
            if (rooting == rootingtype.minvar)
            {
                LINK.score[gp - 1] = LINK.score[rootnode - 1];
                LINK.score[rootnode - 1] = LINK.score[nde - 1];
            }
            else
            {
                LINK.score[gp - 1] = 0.0;
                LINK.score[rootnode - 1] = 0.0;
            }
            /* if (rooting=specified) */
            rootarclength = length_[nde - 1];
            return LINK;
        }  /* changeroot */
        #endregion
        #region findbestroot
        /************************************************************************/
        /* findbestroot: find optimal rooting of the tree                       */
        /*               (for rooting=minvar or rooting=specified)              */
        /************************************************************************/
        void findbestroot()
        {
            LOC_findbestroot V = new LOC_findbestroot();
            V.score = new double[twiceobject];
            long ch1, ch2;
            bool foundroot = false;

            if (rooting == rootingtype.specified)
                V.score[rootnode - 1] = 0.0;
            else if (rooting == rootingtype.minvar)
                V.score[rootnode - 1] = leafss[rootnode - 1];
            do
            {
                V.minscore = V.score[rootnode - 1];
                V.parentlength = rootarclength;
                ch1 = (long)child[rootnode - 1, 0];
                ch2 = (long)child[rootnode - 1, 1];

                V.parentcount = (long)leafcount[ch2 - 1];
                V.parentheight = height[ch2 - 1];
                V.parentss = leafss[ch2 - 1];

                V = checkchild(ch1, ch2, (long)child[ch1 - 1, 0], (long)child[ch1 - 1, 1], V);
                V = checkchild(ch1, ch2, (long)child[ch1 - 1, 1], (long)child[ch1 - 1, 0], V);

                V.parentcount = (long)leafcount[ch1 - 1];
                V.parentheight = height[ch1 - 1];
                V.parentss = leafss[ch1 - 1];

                V = checkchild(ch2, ch1, (long)child[ch2 - 1, 0], (long)child[ch2 - 1, 1], V);
                V = checkchild(ch2, ch1, (long)child[ch2 - 1, 1], (long)child[ch2 - 1, 0], V);

                if (V.minscore >= V.score[rootnode - 1])
                    foundroot = true;
                else
                {
                    V = changeroot(V.goodnode, V.badnode, V.goodchild, V.badchild, V);

                }
            } while (!foundroot);

        }  /* findbestroot */
        #endregion
        #region descend
        /* descend calculates:
              vertical position of a branch ("yposition")
              horizontal position of branch ("height")
              endpoints of vertical connecting lines ("topkid","bottomkid")  */
        LOC_drawtree descend(long nde, LOC_drawtree LINK)
        {
            long i;

            if (nde != rootnode)
                height[nde - 1] = height[(int)parent[nde - 1] - 1] + length_[nde - 1];

            if (nde <= numobject)
            {   /* if nde is a leaf */
                LINK.numleaf++;
                LINK.yposition[nde - 1] = LINK.numleaf * 2 - 1;
                return LINK;
            }
            for (i = 0; i <= 1; i++)
            {
                LINK = descend((long)child[nde - 1, i], LINK);
                LINK.yposition[nde - 1] += (long)(LINK.yposition[(long)child[nde - 1, i] - 1] * (double)leafcount[(long)child[nde - 1, i] - 1]);
            }
            LINK.yposition[nde - 1] /= (long)leafcount[nde - 1];
            LINK.topkid[nde - 1] = LINK.yposition[(long)child[nde - 1, 0] - 1];
            LINK.bottomkid[nde - 1] = LINK.yposition[(long)child[nde - 1, 1] - 1];
            /* if nde is an interior Node */
            return LINK;
        }  /* descend */
        #endregion
        #region drawtree
        void drawtree()
        {
            LOC_drawtree V = new LOC_drawtree();
            V.yposition = new long[twiceobject];
            V.topkid = new long[twiceobject];
            V.bottomkid = new long[twiceobject];

            long i, x, y, start, stop, maxstop, node;
            double maxheight = 0.0;
            double stretch;
            char[] line = new char[500];
         
            long FORLIM, FORLIM1, FORLIM2;

            height[rootnode - 1] = 0.0;
            V.numleaf = 0;
            FORLIM = numnode;
            for (i = numobject; i < FORLIM; i++)
                V.yposition[i] = 0;

            V=descend(rootnode, V);

            if (numobject != V.numleaf)
                fprintf("error in descend, numleaf=" + V.numleaf + "\n");
            FORLIM = numobject;
            for (i = 0; i < FORLIM; i++)
            {
                if (height[i] > maxheight)
                    maxheight = height[i];
            }
            stretch = (linesize - namelength - 8) / maxheight;


            FORLIM = numobject * 2;
            /* write tree arcs (horizontal lines) */
            for (y = 1; y <= FORLIM; y++)
            {
                maxstop = 0;
                FORLIM1 = linesize;
                for (i = 0; i < FORLIM1; i++)
                    line[i] = ' ';
                FORLIM1 = numnode;
                for (node = 0; node < FORLIM1; node++)
                {
                    if (V.yposition[node] == y)
                    {
                        if (parent[node] != 0)
                            start = (long)(stretch * height[(int)parent[node] - 1]) + 1;
                        else
                            start = 1;
                        stop = (long)(stretch * height[node]) + 1;
                        if (stop > maxstop)
                            maxstop = stop;
                        if (stop > linesize)
                            stop = linesize;
                        for (x = start - 1; x < stop; x++)
                            line[x] = horizchar;
                    }

                    /* place vertical conecting lines */
                    if (node + 1 > numobject)
                    {
                        if (y > V.topkid[node] && y < V.bottomkid[node])
                        {
                            stop = (long)(stretch * height[node]) + 1;
                            if (stop > maxstop)
                                maxstop = stop;
                            line[stop - 1] = vertchar;
                        }
                    }

                }  /* loop on node */

                for (i = 0; i < maxstop; i++)
                    escreve(line[i]);
                FORLIM1 = numobject;
                for (i = 1; i <= FORLIM1; i++)
                {
                    if (V.yposition[i - 1] == y)
                    {
                        if (printnumbers)
                            escreve(i.ToString());
                        else
                            escreve("  ");
                        FORLIM2 = namelength;
                    //    for (j = 0; j < FORLIM2; j++)
                        escreve(name[i - 1]);
                    }
                }
                escreveEnter("");
            }

        }  /* drawtree */
        #endregion
        #region report
        /************************************************************************/
        /* report: write tree structure and arc-Length estimates; draw tree     */
        /************************************************************************/
        public void report()
        {
            long i, j, FORLIM;

            ReportGT rgt;
            fprintf(""); fprintf(""); fprintf(""); fprintf("");
            fprintf("Node     Length    children");
            FORLIM = numnode;
            for (i = 1; i <= FORLIM; i++)
            {
                rgt = new ReportGT();
                rgt.Node = (int)i;
                write(i.ToString() + "    ");
                rgt.Length = length_[i - 1];
                write(length_[i - 1].ToString() + "     ");

                if (i <= numobject)
                {
                    write("                  ");
                    write(name[i - 1]);
                    rgt.Name = name[i - 1];
                }
                else
                {
                    for (j = 0; j <= 1; j++)
                    {
                        if (j == 0)
                            rgt.Children1 = (int)child[i - 1, j];
                        else
                            rgt.Children2 = (int)child[i - 1, j];

                        write(child[i - 1, j].ToString() + " ");
                    }
                }
                listaResult.Add(rgt);
                putc('\n');
            }
            //fprintf("\n\n\n\n");

            //if (printtree)
            treeGrafic = "";
            drawtree();
            //fprintf("\n\n\n\n");

            //if (!printheight)
            //  return;

            //fprintf("distance of each Node from the root:");
            //fprintf("Node   height");
            //FORLIM = numnode;
            //for (i = 1; i <= FORLIM; i++)
            //  fprintf(i.ToString() + "   " + height[i-1].ToString() + " ");
            //fprintf("\n\n\n\n");
        }  /* report */
        #endregion
        #region derivedistances
        LOC_stats derivedistances(LOC_stats LINK)
        {
            long i, j, k;
            long ij = 0;
            long FORLIM, FORLIM2;

            FORLIM = numobject;
            for (i = 2; i <= FORLIM; i++)
            {
                for (j = 1; j < i; j++)
                {
                    ij++;
                    LINK.modeldis[ij - 1] = 0.0;
                    FORLIM2 = numnode;
                    for (k = 0; k < FORLIM2; k++)
                    {
                        if ((i == branchset[k, 0] && j != branchset[k, 0]) || (j == branchset[k, 0] && i != branchset[k, 0]))
                            LINK.modeldis[ij - 1] += length_[k];
                    }
                }
            }
            return LINK;
        }  /* derivedistances */
        #endregion
        #region quicksort
        LOC_stats quicksort(long lowerbound, long upperbound, LOC_stats LINK)
        {
            if (upperbound > lowerbound + 1)
            {
                x = lowerbound + 1;
                y = upperbound;
                while (x <= y)
                {
                    if (prox[LINK.c[x - 1] - 1] <= prox[LINK.c[lowerbound - 1] - 1])
                    {
                        x++;
                        continue;
                    }
                    while (prox[LINK.c[y - 1] - 1] > prox[LINK.c[lowerbound - 1] - 1])
                        y--;
                    if (x >= y)
                        continue;
                    hold = LINK.c[x - 1];
                    LINK.c[x - 1] = LINK.c[y - 1];
                    LINK.c[y - 1] = hold;
                    x++;
                    y--;
                }
                hold = LINK.c[lowerbound - 1];
                LINK.c[lowerbound - 1] = LINK.c[y - 1];
                LINK.c[y - 1] = hold;
                LINK = quicksort(lowerbound, y - 1, LINK);
                LINK = quicksort(y + 1, upperbound, LINK);
                return LINK;
            }
            if (upperbound != lowerbound + 1)   /* prox has only two elements */
                return LINK;
            if (prox[LINK.c[lowerbound - 1] - 1] <= prox[LINK.c[upperbound - 1] - 1])
                return LINK;
            hold = LINK.c[lowerbound - 1];
            LINK.c[lowerbound - 1] = LINK.c[upperbound - 1];
            LINK.c[upperbound - 1] = hold;
            return LINK;
        }  /* quicksort */
        #endregion
        #region lsmonotransform
        LOC_stats lsmonotransform(double[] modeldis, double[] d, LOC_stats LINK, out double[] modeldis1, out double[] d1)
        {
            long i, j, place, ordered;
            double bin;
            long endcondition;

            do
            {
                ordered = 1;
                i = 1;
                do
                {
                    if (d[LINK.c[i] - 1] < d[LINK.c[i - 1] - 1])
                    {
                        ordered = 0;
                        endcondition = 0;
                        bin = d[LINK.c[i - 1] - 1];
                        place = i;
                        do
                        {
                            place++;
                            bin += d[LINK.c[place - 1] - 1];
                            if (place == numprox)
                                endcondition = 1;
                            else if (d[LINK.c[place] - 1] > bin / (place - i + 1))
                                endcondition = 1;
                        } while (endcondition != 1);
                        for (j = i - 1; j < place; j++)
                            d[LINK.c[j] - 1] = bin / (place - i + 1);
                        i = place;
                    }
                    i++;
                } while (i < numprox);
            } while (ordered != 1);

            d1 = d;
            modeldis1 = modeldis;
            return LINK;
        }  /* lsmonotransform */
        #endregion


        public Tree(ArrayList listaNomes_, ArrayList listaDados_)
        {
            try
            {
                listaResult = new ArrayList();
                listaNomes = listaNomes_;
                listaDados = listaDados_;
                //tw = new StreamWriter(path);
                for (int init = 0; init < twiceobject; init++)
                    parent[init] = 0;
                linesize = linelength;
                rooting = rootingtype.minvar;
                similarities = false;
                subtractconstant = true;

                for (int ka = 0; ka < listaNomes.Count; ka++)
                    name[ka] = listaNomes[ka].ToString();
                int contador = 0;
                for (int ka = 0; ka < listaDados.Count; ka++)
                    for (int kb = 0; kb < ((ArrayList)listaDados[ka]).Count; kb++)
                    {
                        prox[contador] = (double)((ArrayList)listaDados[ka])[kb];
                        contador++;
                    }

                numobject = listaNomes.Count;

                int aux = 0;
                for (aux = 0; aux < prox.Length; aux++)
                    if (prox[aux] == 0.0)
                        break;
                numprox = aux;

                long FORLIM;
                chkmetric();

                initialize();

                fprintf("fitting tree..");

                /* main clustering loop **********************************/
                while (n >= 4)
                {
                    numgroup = 0;
                    nreduce = 0;
                    findgroups();

                    FORLIM = n;
                    for (int_ = 1; int_ <= FORLIM; int_++)
                        use[int_ - 1] = true;
                    FORLIM = numgroup;
                    for (whichgroup = 1; whichgroup <= FORLIM; whichgroup++)
                        makenode();


                    cleanup();
                }

                /* end main clustering loop ******************************/
                /* choose a root for the tree (now there are n=3 or n=2 nodes left) */
                if (n == 3)
                {
                    numgroup = 1;
                    whichgroup = 1;
                    if (height[(long)index_[0] - 1] > height[(long)index_[1] - 1] && height[(long)index_[0] - 1] > height[(long)index_[2] - 1])
                    {

                        group[0, 0] = 2;
                        group[0, 1] = 3;
                    }
                    else if (height[(long)index_[1] - 1] > height[(long)index_[0] - 1] &&
                         height[(long)index_[1] - 1] > height[(long)index_[2] - 1])
                    {
                        group[0, 0] = 1;
                        group[0, 1] = 3;
                    }
                    else
                    {
                        //   group[0, 0] = group[0, 0] + group[0, 1];
                        group[0, 0] = 1;
                        group[0, 1] = 2;
                    }
                    for (int_ = 1; int_ <= 3; int_++)
                        use[int_ - 1] = true;
                    makenode();
                    cleanup();
                }

                /* now n=2 */
                makeroot();
                hangroot();
                if (rooting != rootingtype.asis)
                {
                    findbestroot();   /* specified rooting or minvarroot */
                    hangroot();
                }

                report();
            }
            catch (Exception ex)
            {
                throw ex;
            }
            finally
            {
                //tw.Close();
            }
        }

        #region Treegrafic builder
        private void escreve(char ch)
        {
            treeGrafic += ch;
        }
        private void escreve(string text)
        {
            treeGrafic += text;
        }

        private void escreveEnter(char ch)
        {
            treeGrafic += ch;
            treeGrafic += "<br />";

        }
        private void escreveEnter(string text)
        {
            treeGrafic += text;
            treeGrafic += "<br />";

        }
        public string getTreeGrafic()
        {
            return treeGrafic;
        }
        #endregion



        #region escrita no ficheiro de texto
        void fprintf(String texto)
        {
         //   tw.WriteLine(texto);
        }
        void putc(char ch)
        {
          //  tw.Write(ch);
        }
        void write(string ch)
        {
          //  tw.Write(ch);
        }
        #endregion
    }
}
