﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Caching;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Xml;
using System.Xml.Linq;
using System.Xml.XPath;
using ExcelLibraries;
using System.IO;
using System.Text;
using System.Threading;

namespace MFCalculator
{
    public partial class Calculator : BasePage
    {
        private bool updateParameters = false;
        private const int MaxFileNameLen = 20;

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                if (Session["GUID"] == null)
                    Session.Add("GUID", System.Guid.NewGuid().ToString());

                this.Master.FindControl("HLSSession").Visible = true;
            }

            if (Session["GUID"] != null)
                GeneratePortlet();

            IBupNF.Attributes["onclick"] = "UpDownTextBox('" + txtNfactor.ClientID + "', 1);";
            IBdownNF.Attributes["onclick"] = "UpDownTextBox('" + txtNfactor.ClientID + "', -1);";

            IBupScore.Attributes["onclick"] = "UpDownTextBox('" + txtScore.ClientID + "', 1); UpDownTextBox('" + txtFrequency.ClientID + "', -1);";
            IBdownScore.Attributes["onclick"] = "UpDownTextBox('" + txtScore.ClientID + "', -1); UpDownTextBox('" + txtFrequency.ClientID + "', 1);";

            IBupFreq.Attributes["onclick"] = "UpDownTextBox('" + txtFrequency.ClientID + "', 1); UpDownTextBox('" + txtScore.ClientID + "', -1);";
            IBdownFreq.Attributes["onclick"] = "UpDownTextBox('" + txtFrequency.ClientID + "', -1); UpDownTextBox('" + txtScore.ClientID + "', 1);";

            ScriptManager.RegisterStartupScript(this, this.GetType(), "ToolTips", @"ddimgtooltip.init('*[rel^=imgtip]');" + Environment.NewLine, true);

            txtNfactor.Attributes["onkeypress"] = "return NumbersOnly();";
            txtScore.Attributes["onkeypress"] = "return NumbersOnly();";
            txtScore.Attributes["onchange"] = "Diferenca('" + txtScore.ClientID + "', '" + txtFrequency.ClientID + "');";
            txtFrequency.Attributes["onkeypress"] = "return NumbersOnly();";
            txtFrequency.Attributes["onchange"] = "Diferenca('" + txtFrequency.ClientID + "', '" + txtScore.ClientID + "');";
        }

        public void GeneratePortlet()
        {
            divLastResult.Controls.Clear();

            HtmlTable table1 = new HtmlTable();
            HtmlTableRow row;
            HtmlTableCell cell;
            LinkButton olk;

            table1.Border = 0;
            table1.CellPadding = 0;
            table1.CellSpacing = 0;

            String nomefile = "";
            int linhas = Session.Count; // numero de ficheiros 

            row = new HtmlTableRow();
            cell = new HtmlTableCell();
            cell.ColSpan = 2;
            cell.Width = "174px";
            cell.InnerText = GetLocalResourceObject("Inputfile").ToString();
            row.Cells.Add(cell);
            cell = new HtmlTableCell();
            cell.ColSpan = 2;
            cell.InnerText = GetLocalResourceObject("ExportTo").ToString();
            row.Cells.Add(cell);

            table1.Rows.Add(row);

            for (int l = 1; l < linhas; l++)
            {
                nomefile = Session[l].ToString();
                row = new HtmlTableRow();
                row.Height = "18px";
                row.BgColor = "FFFFFF";// (l % 2 == 0 ? "#F5F5F5" : "#FFFFFF");

                cell = new HtmlTableCell();
                cell.Width = "15px";
                olk = new LinkButton();
                olk.ID = "delete" + l.ToString();
                olk.CommandName = olk.ID;
                olk.CommandArgument = "delete:" + l.ToString();
                olk.Style.Add("text-decoration", " none");
                olk.Attributes.Add("onClick", "return confirm('" + GetLocalResourceObject("ConfirmDelete").ToString() + "');");
                olk.Click += new EventHandler(DataResultList_Click);
                olk.ToolTip = GetLocalResourceObject("deletefile").ToString();
                olk.Text = " <img alt='" + olk.ToolTip + "' src=\"Images/remove.png\" border=\"0\" />";
                cell.Controls.Add(olk);
                row.Cells.Add(cell);

                cell = new HtmlTableCell();
                cell.Width = "174px";
                olk = new LinkButton();
                olk.ID = "run" + l.ToString();
                olk.CommandName = olk.ID;
                olk.CommandArgument = "run:" + l.ToString();
                olk.Style.Add("font-weight", "normal");
                olk.Style.Add("text-decoration", " none");
                olk.ToolTip = GetLocalResourceObject("Calculate").ToString() + "..." + nomefile;
                FileInfo fi = new FileInfo(Server.MapPath("~/temporaryFiles/" + Session["GUID"].ToString() + "/") + nomefile);
                olk.Text = " &nbsp;" + nomefile.Substring(0, nomefile.Length > MaxFileNameLen ? MaxFileNameLen : nomefile.Length) +
                    (nomefile.Length > MaxFileNameLen ? "..." : " ") +
                    GetLocalResourceObject("at").ToString() + " " + fi.CreationTime.ToString("HH:mm");
                olk.Click += new EventHandler(DataResultList_Click);
                cell.Controls.Add(olk);
                row.Cells.Add(cell);

                cell = new HtmlTableCell();
                olk = new LinkButton();
                olk.ID = "excel" + l.ToString();
                olk.CommandName = olk.ID;
                olk.CommandArgument = "excel:" + l.ToString();
                olk.Style.Add("text-decoration", " none");
                olk.Click += new EventHandler(DataResultList_Click);
                olk.ToolTip = GetLocalResourceObject("Excel").ToString();
                olk.Text = " <img alt='" + olk.ToolTip + "' src=\"Images/excel.png\" border=\"0\" />";
                cell.Controls.Add(olk);
                row.Cells.Add(cell);

                cell = new HtmlTableCell();
                olk = new LinkButton();
                olk.ID = "word" + l.ToString();
                olk.CommandName = olk.ID;
                olk.CommandArgument = "word:" + l.ToString();
                olk.Style.Add("text-decoration", " none");
                olk.Click += new EventHandler(DataResultList_Click);
                olk.ToolTip = GetLocalResourceObject("Word").ToString();
                olk.Text = " <img alt='" + olk.ToolTip + "' src=\"Images/word.png\" border=\"0\" />";
                cell.Controls.Add(olk);
                row.Cells.Add(cell);

                cell = new HtmlTableCell();
                olk = new LinkButton();
                olk.ID = "csv" + l.ToString();
                olk.CommandName = olk.ID;
                olk.CommandArgument = "csv:" + l.ToString();
                olk.Style.Add("text-decoration", " none");
                olk.Click += new EventHandler(DataResultList_Click);
                olk.ToolTip = GetLocalResourceObject("CSV").ToString();
                olk.Text = " <img alt='" + olk.ToolTip + "' src=\"Images/csv.png\" border=\"0\" width='16px' />";
                cell.Controls.Add(olk);
                row.Cells.Add(cell);

                table1.Rows.Add(row);
            }

            divLastResult.Controls.Add(table1);
        }


        protected void DataResultList_Click(object sender, EventArgs e)
        {
            var button = sender as LinkButton;

            try
            {
                string[] args = button.CommandArgument.ToString().Split(':');
                string command = args[0];
                hfFile.Value = args[1];

                string fileName = Session[Convert.ToInt32(hfFile.Value)].ToString();

                switch (command)
                {
                    case "excel":
                    case "word":
                        SetCalcType();
                        GenerateHeaderForExcelWord(fileName);

                        string exportFileName = (fileName.Remove(fileName.Length - 4)).ToString() + "-" + hfView.Value.ToString() + (command == "word" ? ".rtf" : ".xls");
                        TextWriter tw = new StreamWriter(Server.MapPath("~/temporaryFiles/" + Session["GUID"].ToString() + "/") + exportFileName);
                        tw.WriteLine(RenderControlHTML(tableView));
                        tw.Close();

                        Response.Redirect("./temporaryFiles/" + Session["GUID"].ToString() + "/" + exportFileName);
                        break;

                    case "csv":
                        SetCalcType();

                        int type = 0;
                        int.TryParse(hfView.Value, out type);

                        var csvContent = new StringBuilder();
                        var mfc = GetCalculator(Convert.ToInt32(hfFile.Value), Convert.ToInt32(txtNfactor.Text), Convert.ToInt32(txtScore.Text), false);

                        for (var line = 0; line <= mfc.NumberOfPersons; line++)
                        {
                            // Add fixed columns for SPSS compatibility
                            if (line == 0)
                                csvContent.Append("ROWTYPE_;ID;CASENO_;VARNAME_;");
                            else
                                csvContent.Append("PROX;" + mfc.Persons[line - 1].Name + ";" + mfc.Persons[line - 1].Name + ";");

                            for (var column = 0; column <= mfc.NumberOfPersons; column++)
                            {
                                // First cell has already been written for SPSS compatibility
                                if (line != 0 || column != 0)
                                {
                                    object mfcValue = mfc.GetMfcValue((MFC.CalculationType)type, line, column);
                                    if (mfcValue == null)
                                        Response.Redirect("~/calculator.aspx");

                                    string value = String.Format("{0:0.##########}", mfcValue);
                                    value = value.Replace(".", Thread.CurrentThread.CurrentCulture.NumberFormat.NumberGroupSeparator);
                                    csvContent.Append(value + ";");
                                }
                            }

                            csvContent.AppendLine();
                        }

                        exportFileName = (fileName.Remove(fileName.Length - 4)).ToString() + "-" + hfView.Value.ToString() + ".csv";
                        tw = new StreamWriter(Server.MapPath("~/temporaryFiles/" + Session["GUID"].ToString() + "/") + exportFileName, false, Encoding.UTF8);
                        tw.Write(csvContent.ToString());
                        tw.Close();

                        Response.Redirect("./temporaryFiles/" + Session["GUID"].ToString() + "/" + exportFileName);
                        break;

                    case "run":
                        // Reset styles on other files
                        for (int i = 1; i < Session.Count; i++)
                        {
                            LinkButton lb = (LinkButton)button.Parent.Parent.Parent.FindControl("run" + i.ToString());
                            if (lb != null)
                                lb.CssClass = "unselected";
                        }

                        // Set current file bold
                        button.CssClass = "selected";

                        SetCalcType(lbResult, MFC.CalculationType.Overall);
                        break;

                    case "delete":
                        CleanCalculator(Server.MapPath("~/temporaryFiles/" + Session["GUID"].ToString() + "/") + fileName);

                        for (int index = 0; index < 3; index++)
                        {
                            try
                            {
                                string exportedFileName = (fileName.Remove(fileName.Length - 4)).ToString() + "-" + index.ToString();

                                File.Delete(Server.MapPath("~/temporaryFiles/" + Session["GUID"].ToString() + "/") + exportedFileName + ".xls");
                                File.Delete(Server.MapPath("~/temporaryFiles/" + Session["GUID"].ToString() + "/") + exportedFileName + ".rtf");
                            }
                            catch (Exception)
                            {
                                // Ignore if files dont exit
                            }
                        }

                        lblNumOfPersons.Text = "";
                        lblNumOfItems.Text = "";
                        hfFile.Value = "0";

                        File.Delete(Server.MapPath("~/temporaryFiles/" + Session["GUID"].ToString() + "/") + fileName);
                        Session.Remove(fileName);
                        GeneratePortlet();

                        break;
                }
            }
            catch (Exception)
            {
            }
        }

        private void GenerateHeaderForExcelWord(string fileName)
        {
            HtmlTable table = new HtmlTable();
            HtmlTableRow row;
            HtmlTableCell cell;

            // Credits table
            row = new HtmlTableRow();
            row.Height = "18px";
            row.BgColor = "#FFFFFF";
            cell = new HtmlTableCell();
            cell.InnerHtml = (hfView.Value == "0" ? lbResult.Text : (hfView.Value == "1" ? lbScore.Text : lbFrequency.Text)).Trim().Replace("&nbsp;", "") + " " + GetLocalResourceObject("ComputedBy").ToString();
            cell.ColSpan = 30;
            cell.Style.Add("font-size", "16px");
            cell.Style.Add("font-weight", "bold");
            row.Cells.Add(cell);
            table.Rows.Add(row);
            tableView.Controls.AddAt(0, table);

            // Info table
            table = new HtmlTable();
            table.Style.Add("border-spacing", " 0px");
            table.Style.Add("border-bottom-width", "1px");
            table.Style.Add("font-size", "12px");

            row = new HtmlTableRow();
            row.Height = "18px";
            table.Rows.Add(row);

            // N Factor
            row = new HtmlTableRow();
            row.Height = "18px";
            row.BgColor = "#FFFFFF";
            cell = new HtmlTableCell();
            cell.InnerHtml = lblFactor.Text;
            row.Cells.Add(cell);
            cell = new HtmlTableCell();
            cell.InnerHtml = txtNfactor.Text;
            row.Cells.Add(cell);
            table.Rows.Add(row);

            // Number of persons
            row = new HtmlTableRow();
            row.Height = "18px";
            row.BgColor = "#FFFFFF";
            cell = new HtmlTableCell();
            cell.InnerHtml = lblPersons.Text.Replace("&nbsp;", "").Replace(":", "");
            row.Cells.Add(cell);
            cell = new HtmlTableCell();
            cell.InnerHtml = lblNumOfPersons.Text;
            row.Cells.Add(cell);
            table.Rows.Add(row);

            // Number of items
            row = new HtmlTableRow();
            row.Height = "18px";
            row.BgColor = "#FFFFFF";
            cell = new HtmlTableCell();
            cell.InnerHtml = lblItens.Text.Replace(":", "");
            row.Cells.Add(cell);
            cell = new HtmlTableCell();
            cell.InnerHtml = lblNumOfItems.Text;
            row.Cells.Add(cell);
            table.Rows.Add(row);

            // File name
            row = new HtmlTableRow();
            row.Height = "18px";
            row.BgColor = "#FFFFFF";
            cell = new HtmlTableCell();
            cell.InnerHtml = GetLocalResourceObject("File").ToString();
            row.Cells.Add(cell);
            cell = new HtmlTableCell();
            cell.InnerHtml = fileName + ", " + DateTime.Now.ToString("dd-MM-yyyy HH:mm:ss");
            cell.ColSpan = 30;
            row.Cells.Add(cell);
            table.Rows.Add(row);

            tableView.Controls.Add(table);
        }

        public string RenderControlHTML(Control ctrl)
        {
            StringBuilder sb = new StringBuilder();
            StringWriter tw = new StringWriter(sb);
            HtmlTextWriter hw = new HtmlTextWriter(tw);

            ctrl.RenderControl(hw);

            sb.Replace("á", "&aacute;").Replace("Á", "&Aacute;").Replace("à", "&agrave;").Replace("À", "&Agrave;").Replace("â", "&acirc;").Replace("Â", "&Acirc;").Replace("ã", "&atilde;").Replace("Ã", "&Atilde;");
            sb.Replace("é", "&eacute;").Replace("É", "&Eacute;").Replace("è", "&egrave;").Replace("È", "&Egrave;").Replace("ê", "&ecirc;").Replace("Ê", "&Ecirc;");
            sb.Replace("í", "&iacute;").Replace("Í", "&Iacute;").Replace("ì", "&igrave;").Replace("Ì", "&Igrave;");
            sb.Replace("ó", "&oacute;").Replace("Ó", "&Oacute;").Replace("ò", "&ograve;").Replace("Ò", "&Ograve;").Replace("ô", "&ocirc;").Replace("Ô", "&Ocirc;").Replace("õ", "&otilde;").Replace("Õ", "&Otilde;");
            sb.Replace("ú", "&uacute;").Replace("Ú", "&Uacute;").Replace("ù", "&ugrave;").Replace("Ù", "&Ugrave;");
            sb.Replace("ç", "&ccedil;").Replace("Ç", "&Ccedil;");
            sb.Replace("®", "&copy;").Replace("ª", "&ordf;").Replace("º", "&ordm;").Replace("€", "&euro;");
            sb.Replace("’", "&rsquo;").Replace("–", "&ndash;").Replace("“", "&ldquo;").Replace("”", "&rdquo;").Replace("·", "&middot;");

            return sb.ToString();
        }



        private void GenerateResult(MFC.CalculationType type)
        {
            if (Session[Convert.ToInt32(hfFile.Value)] == null)
                return;

            // Get calculation
            DateTime start = DateTime.Now;
            var mfc = GetCalculator(Convert.ToInt32(hfFile.Value), Convert.ToInt32(txtNfactor.Text), Convert.ToInt32(txtScore.Text), updateParameters);
            DateTime end1 = DateTime.Now;

            // Nothing to process
            if (mfc.NumberOfPersons == 0 || mfc.NumberOfItems == 0)
                return;

            lblNumOfPersons.Text = mfc.NumberOfPersons.ToString();
            lblNumOfItems.Text = mfc.NumberOfItems.ToString();

            // Reset view
            tableView.Controls.Clear();
            HtmlTableRow row = null;
            HtmlTableCell cell = null;

            HtmlTable table = new HtmlTable();
            var evenOddClass = "even";

            for (var line = 0; line <= mfc.NumberOfPersons; line++)
            {
                row = new HtmlTableRow();

                if (line <= 1 || evenOddClass == "odd")
                    evenOddClass = "even";
                else
                    evenOddClass = "odd";
                row.Attributes["class"] = evenOddClass;

                for (var column = 0; column <= mfc.NumberOfPersons; column++)
                {
                    cell = new HtmlTableCell();

                    object mfcValue = mfc.GetMfcValue(type, line, column);
                    if (mfcValue == null)
                        Response.Redirect("~/calculator.aspx");

                    // Cells with values
                    if (line > column && column > 0)
                    {
                        //cell.Attributes["title"] = String.Format("{0:0.0000000000}", values[line][column]);
                        //cell.InnerHtml = "&nbsp;&nbsp;" + String.Format("{0:0.##}", values[line][column]) + "&nbsp;&nbsp;";
                        string value = String.Format("{0:0.##}", mfcValue);
                        cell.InnerHtml = value.Replace(".", Thread.CurrentThread.CurrentCulture.NumberFormat.NumberGroupSeparator);
                    }
                    else
                    {
                        cell.InnerHtml = mfcValue.ToString();

                        // First cell
                        if (line == 0 && column == 0)
                            cell.Attributes["class"] = "fce";

                        // First line
                        if (line == 0 && column > 0)
                            cell.Attributes["class"] = "fli";

                        // First column
                        if (line > 0 && column == 0)
                            cell.Attributes["class"] = "fco";
                    }

                    // Last line
                    if (line == mfc.NumberOfPersons)
                        cell.Attributes["class"] += " lli";

                    // Last column, or second line, or diagonal values should be hidden in site, but visible in excel and csv formats
                    if (column == mfc.NumberOfPersons || line == 1 || (line == column && line > 0))
                        cell.Attributes["class"] += " diag";

                    row.Cells.Add(cell);
                }

                table.Rows.Add(row);
            }

            // Table footer
            AddFooterRowToTable(table, lblAverage.Text, mfc.GetMfcAverage(type));
            AddFooterRowToTable(table, GetLocalResourceObject("Maximum").ToString(), mfc.GetMfcMaximum(type));
            AddFooterRowToTable(table, GetLocalResourceObject("Minimum").ToString(), mfc.GetMfcMinimum(type));
            AddFooterRowToTable(table, GetLocalResourceObject("StandardDeviation").ToString(), mfc.GetMfcDeviation(type));

            tableView.EnableViewState = false;
            tableView.Controls.Add(table);

            TimeSpan tsEnd1 = end1 - start;
            TimeSpan tsEnd2 = DateTime.Now - end1;

            if (Request.QueryString["debug"] == "on")
                ScriptManager.RegisterStartupScript(this, this.GetType(), "TraceTime", @"alert('" + tsEnd1.ToString() + " :<->: " + tsEnd2.ToString() + "');", true);
        }

        private void AddFooterRowToTable(HtmlTable table, string label, double value)
        {
            var row = new HtmlTableRow();
            row.Height = "18px";
            row.BgColor = "#FFFFFF";
            row.Style["font-size"] = "11px";

            var cell = new HtmlTableCell();
            cell.InnerHtml = label;
            cell.Attributes.Add("title", label);
            row.Cells.Add(cell);

            cell = new HtmlTableCell();
            //cell.Attributes["title"] = String.Format("{0:0.0000000000}", average);
            cell.InnerHtml = String.Format("{0:0.##}", value).Replace(".", Thread.CurrentThread.CurrentCulture.NumberFormat.NumberGroupSeparator);
            row.Cells.Add(cell);
            table.Rows.Add(row);
        }

        private void SetCalcType()
        {
            int type = 0;
            int.TryParse(hfView.Value, out type);

            SetCalcType(null, (MFC.CalculationType)type);
        }

        private void SetCalcType(LinkButton button, MFC.CalculationType type)
        {
            if (button != null)
            {
                // Reset all styles
                lbScore.CssClass = "unselected";
                lbFrequency.CssClass = "unselected";
                lbResult.CssClass = "unselected";

                // Mark selected style
                button.CssClass = "selected";
            }

            // Calculate
            hfView.Value = ((int)type).ToString();
            GenerateResult(type);
        }

        protected void CalcType_Click(object sender, EventArgs e)
        {
            int type = 0;
            int.TryParse((sender as LinkButton).CommandArgument, out type);
            hfView.Value = type.ToString();

            SetCalcType(sender as LinkButton, (MFC.CalculationType)type);
        }

        protected void UpDown_Click(object sender, EventArgs e)
        {
            if (Session.Count <= 1)
                return;

            updateParameters = true;
            SetCalcType();
        }

        protected override void Render(HtmlTextWriter writer)
        {
            StringBuilder sb = new StringBuilder();
            StringWriter tw = new StringWriter(sb);

            sb.Replace("&#39;", "'");

            base.Render(writer);
        }
    }
}
