﻿<%@ Page Language="C#" MasterPageFile="~/Masters/layout.Master" EnableViewState="false" AutoEventWireup="true" CodeBehind="default.aspx.cs" Inherits="MFCalculator.Default" Title="MF Calculator" %>

<asp:Content ID="Content2" ContentPlaceHolderID="CPHbody" runat="server">
<div class="centralDefault">
    <div>&nbsp;</div>
    <div class="menu">
        <div>
            <div class="lateralImageDefualt"> 
                <div class="lateraltitle" >&nbsp; Menu </div>
            </div>
            <div class="lateralImageFundo"></div>
            <div>
                <ul>
                    <li>
                        <asp:HyperLink ID="hypCalculator" runat="server" NavigateUrl="~/calculator.aspx" meta:resourcekey="HLCalculatorResource" />
                    </li>
                    <li>
                        <asp:HyperLink ID="hypMenu1" runat="server" NavigateUrl="~/default.aspx?id=1" meta:resourcekey="HLInstrucoes1" />
                    </li>
                    <ul style="padding-left: 10px">
                        <li>
                            <asp:HyperLink ID="hypMenu2" runat="server" NavigateUrl="~/default.aspx?id=2" meta:resourcekey="HLInstrucoes2" />
                        </li>
                        <li>
                            <asp:HyperLink ID="hypMenu3" runat="server" NavigateUrl="~/default.aspx?id=3" meta:resourcekey="HLInstrucoes3" />
                        </li>
                        <li>
                            <asp:HyperLink ID="hypMenu4" runat="server" NavigateUrl="~/default.aspx?id=4" meta:resourcekey="HLInstrucoes4" />
                        </li>
                        <li>
                            <asp:HyperLink ID="hypMenu5" runat="server" NavigateUrl="~/default.aspx?id=5" meta:resourcekey="HLInstrucoes5" />
                        </li>
                    </ul>
                </ul> 
            </div>
        </div>
    </div>

    <div class="ConteudoDefault">
        <asp:Literal ID="lblContent" runat="server" />

        <asp:PlaceHolder ID="phContent0" runat="server" Visible="false">
            <b>What is the MF Calculator?</b>
            <p>
                The MF Calculator is an application to analyze similarity in ill-structured data sets.
                It can be used when there is little prior control of the variables to be observed, both
                regarding their number and/or content.
            </p>
            <p>
                The MF Calculator implements the Metric-Frequency algorithm developed by Sales & Wakker (2009).
            </p>
            <p>
                The MF Calculator is explained in the paper “MF Calculator: A web-based application for analyzing similarity”, by Sales, Wakker, Alves & Faísca (2013).
            </p>

            <b>Main features of the MF Calculator</b>
            <p>
                The MF Calculator provides a similarity matrix in CSV, XLS or DOC as well as its graphical representation in additive trees (Corter, 1982; Sattath & Tversky, 1977).
            </p>
            <p>
                Results may be exported to other statistical software, such as SPSS or MS Excel, for subsequent analysis (see Sales, Wakker, Alves & Faísca (2013).
            </p>
            <p>
                The MF Calculator is recommended for samples with up to 500 cases.
            </p>

            <b>Credits</b>
            <p>
                When applying the MF Calculator, the following references should be used:
            </p>
            <p>
                Sales, C. M. D. & Wakker, P. P. (2009). The metric-frequency measure of similarity for ill-structured data sets, with an application to family therapy. 
                The British Journal of Mathematical and Statistical Psychology, 62(3), 663-682. <a target="_blank" href="resources/ArtigoPublicado.pdf">(download)</a>
            </p>
            <p>
                Sales, C. M. D, Wakker, P. P., Alves, P. C. G & Faísca, L. (2013). MF Calculator: A web-based application for analyzing similarity. Submitted for publication. (download)
            </p>
        </asp:PlaceHolder>

        <asp:PlaceHolder ID="phContent1" runat="server" Visible="false">
            <div class="helpTitle"></div>
            <p>
                The main steps for using the MF Calculator are:
                <ul style="list-style-type: decimal">
                    <li>Preparing the input database in your computer</li>
                    <li>Uploading the database, calculating and visualizing the results in your computer screen</li>
                    <li>Downloading the MF outputs in several formats (DOC, XLS, CSV, Graph)</li>
                </ul>
            </p>
            <p>
                A detailed explanation of these procedures is provided in the step-by-step guides on the menu.
            </p>
            <p>
                If you experience any difficulty using the MF Calculator, contact <a href="mailTo:celiasales@uevora.pt">celiasales@uevora.pt</a>.
            </p>
        </asp:PlaceHolder>

        <asp:PlaceHolder ID="phContent2" runat="server" Visible="false">
            <div class="helpTitle"></div>
            <b>Structure of the input database</b>
            <p>
                The rows must contain the cases for comparison
                <ul>
                    <li>The first row must always have the names of the cases</li>
                </ul>
            </p>
            <p>
                The columns must contain the items or variables
                <ul>
                    <li>The first row must always identify the cases (STRING variable). 
                        If your cases are identified with numbers, make sure you add a letter before the number (Ex.: instead of 1, 2, 3 write C1, C2, C3)
                    </li>
                </ul>
            </p>
            <p>
                The cells must contain the scores
                <ul>
                    <li>A zero must be assigned in cases of no answer</li>
                </ul>
            </p>
            <p>
                Example 
                <br /><br />
                <img width="500" alt="" src="resources/excel3.jpg" />
            </p>
            <p>
                For more examples see Sales & Wakker, 2009 (p.665) and Sales, Wakker, Alves & Faísca, 2013.
            </p>
            <br />
            <b>Saving as CSV</b>
            <p>
                The MF Calculator supports databases in CSV (comma separated values).
            </p>
            <p>
                To transform your database in CSV, save the file as “CSV (comma separated values)”.
            </p>
            <p>
                Close your file, which is now ready to be uploaded to the MF Calculator.
            </p>
        </asp:PlaceHolder>

        <asp:PlaceHolder ID="phContent3" runat="server" Visible="false">
            <div class="helpTitle"></div>
            <p>
                The MF similarity is computed in the section “Calculator” of this website. The steps are the following.
            </p>
            <p>
                Upload the CSV file with the database by clicking in “Open INPUT File”. Choose the N factor:
                <ul>
                    <li>N should be equal to or larger than the total number of comparison variables</li>
                    <li>For instance, if cases are been compared in 5 variables, then N should be &ge; 5 (for more examples see Sales, Wakker, Alves & Faísca, 2013)</li>
                </ul>
            </p>
            <p>
                To calculate the similarity, click in the name of the input database.
            </p>
            <p>
                The similarity matrix will appear on the screen (Overall similarity). To compute “Score similarity” or “Frequency similarity”, click in the respective button.
            </p>
            <p>
                Click in “Display graph” to visualize the similarity tree. For samples &gt; 50, we recommend exporting the similarity matrix (CSV format) 
                and using other software for graphic display (example, hierarchical cluster analysis).
            </p>
            <p>
                Note: if the internet browser is closed the file must be re-uploaded to the website.
            </p>
        </asp:PlaceHolder>

        <asp:PlaceHolder ID="phContent4" runat="server" Visible="false">
            <div class="helpTitle"></div>
            <p>
                The MF outputs must be saved on a computer drive, as they will be lost when the internet browser is closed.
            </p>
            <p>
                The MF outputs are available in DOC, XLS and CSV files.
            </p>
            <br />
            
            <b>Downloading Similarity Matrixes</b>
            <p>
                To download the results, click in the icons (DOC, XLS or CSV) which are next to the database’s name.
            </p>
            <br />

            <b>Downloading Similarity Trees (graphs)</b>
            <p>
                To download the similarity trees that appear on the screen, click in the button DOC that is available in the top right corner.
            </p>
            <p>
                Similarity trees in the MF Calculator are recommended for sample sizes &le; 50.
            </p>
            <br />

            <b>Interface with other statistical software</b>
            <p>
                The MF output matrix can be used as input of traditional statistical techniques such as hierarchical clustering, additive trees or multidimensional scaling.
            </p>
            <p>
                It is recommended that the MF outputs are exported as CSV files so they can be analysed in other statistical software 
                (e.g. see Sales, Wakker, Alves & Faísca, 2013 for an example with cluster analyses).
            </p>
        </asp:PlaceHolder>

        <asp:PlaceHolder ID="phContent5" runat="server" Visible="false">
            <div class="helpTitle"></div>
            <b>There is a missing value in my database. What should I do?</b>
            <p>
                Missing data (i.e. where a cell does not contain any information) are automatically assumed as score of zero.
            </p>
            <p>
                A score of zero means that the variable (column) was not chosen for that case (line).
            </p>
            <br />
            <b>A case rates the same variable more than once. How should I do structure the database?</b>
            <p>
                It can happen that the same variable is raised and given a score more than once.
            </p>
            <p>
                In those situations the highest score should be included in the database (see Sales & Wakker, 2009, p. 675).
            </p>
            <br />
            <b>How to transform the MF calculator matrix in a similarity matrix to use in SPSS?</b>
            <p>
                To import a CSV file in SPSS, you can open the menu “Text import wizard” and tick the option “Semicolon” in “Which delimiters appear between variables”.
            </p>
            <p>
                Alternatively, open the CSV in MS Excel and then save it as an Excel file; then, open it in SPSS, doing the following steps:
                <ul>
                    <li>Check if the variables <b>ROWTYPE_</b>, <b>CASENO_</b> and <b>VARNAME_</b> maintain the underscore. 
                        The underscore is mandatory so that SPSS may recognize the file as a similarity matrix. If necessary, you may rename these variables in variableview
                    </li>
                    <li>
                        In variable view, check if the variable ROWTYPE_ has 8 characters of width; amend this if necessary
                    </li>
                    <li>
                        In variableview, insert the label SIMILARITY in the PROX value of the variable ROWTYPE_ (values)
                    </li>
                </ul>
            </p>
            <p>
                By saving the file, it will be ready to be analysed by SPSS as a similarity matrix.
            </p>
            <p>
                The values in the file will appear as 0 or 1, since they will appear without decimals. 
                If you wish to visualize the MF value, you must alter the number of decimals in variableview (decimals).
            </p>

            <br />
            <b>After importing the MF matrix to SPSS, the MF values do not appear in variableview. What can I do?</b>
            <p>
                It is possible that there is some incompatibility between the MS Excel version you are using and the SPSS version.
            </p>
            <p>
                Preferably, you should import the CSV file in SPSS through the menu “Text import wizard”.
            </p>
            <p>
                You also may open the CSV file in MS Excel and replace all commas by dots. Save your file and try to open it again in SPSS.
            </p>
        </asp:PlaceHolder>




        <asp:PlaceHolder ID="phContentPT0" runat="server" Visible="false">
            <b>O que é o Calculador MF?</b>
            <p>
                O Calculador MF é uma aplicação para o cálculo da similitude de dados pouco estruturados. 
                Permite comparar casos quando não existe controlo a priori sobre as variáveis de comparação, quer quanto ao número, quer no conteúdo.
            </p>
            <p>
                O Calculador MF implementa o algoritmo de similitude Métrica e de Frequência (MF Similarity), proposto por Sales & Wakker (2009).
            </p>
            <p>
                O Calculador MF é apresentado no artigo “MF Calculator: A web-based application for analyzing similarity”, de Sales, Wakker, Alves & Faísca (2013).
            </p>

            <b>Principais características do Calculador MF</b>
            <p>
                O Calculador MF produz matrizes de similitude em CSV, XLS e DOC e representa-as graficamente em additive trees (Corter, 1982; Sattath & Tversky, 1977).
            </p>
            <p>
                Os resultados podem ser exportados para outros programas estatísticos, como o SPSS ou o MS Excel, para análises posteriores (ver Sales, Wakker, Alves & Faísca, 2013).
            </p>
            <p>
                O Calculador MF é recomendado para amostras com uma dimensão até 500 casos.
            </p>

            <b>Créditos</b>
            <p>
                Sempre que usar o Calculador MF, faça por favor as seguintes citações:
            </p>
            <p>
                Sales, C. M. D. & Wakker, P. P. (2009). The metric-frequency measure of similarity for ill-structured data sets, with an application to family therapy. 
                <i>The British Journal of Mathematical and Statistical Psychology</i>, 62(3), 663-682. <a target="_blank" href="resources/ArtigoPublicado.pdf">(download)</a>
            </p>
            <p>
                Sales, C. M. D, Wakker, P. P., Alves, P. C. G & Faísca, L. (2013). MF Calculator: A web-based application for analyzing similarity. Submitted for publication. (download)
            </p>
        </asp:PlaceHolder>

        <asp:PlaceHolder ID="phContentPT1" runat="server" Visible="false">
            <div class="helpTitle"></div>
            <p>
                Os principais passos para o uso do Calculdor MF são:
                <ul style="list-style-type: decimal">
                    <li>Preparar a base de dados no seu computador</li>
                    <li>Fazer upload, calcular a similitude e visualizar os resultados no ecrã</li>
                    <li>Exportar os resultados em vários formatos (DOC, XLS, CSV, Graph)</li>
                </ul>
            </p>
            <p>
                Para uma explicação detalhada destes procedimentos, siga as instruções passo a passo que se encontram no menu.
            </p>
            <p>
                Em caso de dúvidas, contacte-nos através de <a href="mailTo:celiasales@uevora.pt">celiasales@uevora.pt</a>.
            </p>
        </asp:PlaceHolder>

        <asp:PlaceHolder ID="phContentPT2" runat="server" Visible="false">
            <div class="helpTitle"></div>
            <b>Estrutura da base de dados</b>
            <p>
                Em linha, os casos que se pretende comparar
                <ul>
                    <li>A primeira linha deverá conter sempre o nome das variáveis</li>
                </ul>
            </p>
            <p>
                Em coluna, os itens ou variáveis
                <ul>
                    <li>A primeira coluna deverá identificar os casos (variável STRING). 
                        Se os casos estiverem identificados com números, acrescentar uma letra antes do número (Ex.: substituir 1, 2, 3 por C1, C2, C3)</li>
                </ul>
            </p>
            <p>
                Nas células, a intensidade de cada variável
                <ul>
                    <li>Colocar um zero em caso de não resposta</li>
                </ul>
            </p>
            <p>
                Exemplo
                <br /><br />
                <img width="500" alt="" src="resources/excel3.jpg" />
            </p>
            <p>
                Para mais exemplos consultar Sales & Wakker, 2009 (p. 665) e Sales, Wakker, Alves & Faísca, 2013.
            </p>
            <br />

            <b>Criar um ficheiro CSV</b>
            <p>
                O Calculador MF suporta bases de dados em formato CSV (separado por vírgulas).
            </p>
            <p>
                Para transformar a base de dados em CSV, escolha a opção “Gravar como” CSV (separado por vírgulas).
            </p>
            <p>
                Feche o ficheiro, que está pronto para ser usado no Calculador MF.
            </p>
        </asp:PlaceHolder>

        <asp:PlaceHolder ID="phContentPT3" runat="server" Visible="false">
            <div class="helpTitle"></div>
            <p>
                A similitude MF é calculada na secção “Calculador”, disponível nesta página. Os passos são os seguintes.
            </p>
            <p>
                Fazer upload do ficheiro CSV com a base de dados carregando em “Abrir ficheiro”. Escolher o factor N:
                <ul>
                    <li>O N deverá ser igual ou superior ao número total de variáveis a comparar</li>
                    <li>Por exemplo, se os casos estão a ser comparados em 5 variáveis, o N deverá ser &ge; 5 
                        (para mais exemplos e critério de escolha do factor N ver Sales, Wakker, Alves & Faísca, 2013)</li>
                </ul>
            </p>
            <p>
                Calcular a similitude, carregando sobre o nome da base de dados.
            </p>
            <p>
                A matriz de resultados MF (Overall Similitude) aparece no ecrã. 
                Para calcular a similitude métrica ou de frequência carregar sobre o botão correspondente.
            </p>
            <p>
                Carregar em “Mostrar gráfico”, para visualizar graficamente a matriz. 
                Com amostras de dimensão &gt; 50 casos, sugerimos a exportação da matriz de similitude (em formato CSV) e a sua representação gráfica, 
                usando outros programas estatísticos (exemplo, análise hierárquica de clusters)
            </p>
            <p>
                Nota: Se encerrar o navegador da internet, terá de voltar a inserir a base de dados nesta página.
            </p>
        </asp:PlaceHolder>

        <asp:PlaceHolder ID="phContentPT4" runat="server" Visible="false">
            <div class="helpTitle"></div>
            <p>
                Os resultados do Calculador MF devem ser transferidos para o seu computador, uma vez que desaparecem quando se fecha a aplicação.
            </p>
            <p>
                Os resultados da matriz estão disponíveis em ficheiros DOC, XLS ou CSV.
            </p>
            <br />
            
            <b>Exportar Matrizes de Similitude</b>
            <p>
                Para exportar os resultados, carregue sobre os ícones (DOC, XLS ou CSV) que se encontram junto ao nome da base de dados.
            </p>
            <br />

            <b>Exportar as Árvores de Similitude (gráficos)</b>
            <p>
                Para exportar a árvore de similitude que aparece no ecrã, carregue sobre o ícone DOC no canto superior direito.
            </p>
            <p>
                Recomenda-se o uso dos gráficos gerados no Calculador MF com amostras &le; 50 casos.
            </p>
            <br />

            <b>Interface com outros softwares estatísticos</b>
            <p>
                A matriz de resultados pode ser usada como input em análises estatísticas tradicionais, tais como análise hierárquica de clusters, 
                árvores aditivas ou escalonamento multidimensional.
            </p>
            <p>
                Recomenda-se a exportação em formato CSV, para analisar os resultados com outros softwares estatísticos 
                (e.g. ver Sales, Wakker, Alves & Faísca, 2013 para um exemplo com análise de clusters).
            </p>
        </asp:PlaceHolder>

        <asp:PlaceHolder ID="phContentPT5" runat="server" Visible="false">
            <div class="helpTitle"></div>
            <b>Existe um dado missing na minha base de dados. O que faço?</b>
            <p>
                Os dados missing (i.e. quando a célula estiver vazia, sem qualquer informação), são tratados pelo sistema como zero.
            </p>
            <p>
                Um valor zero significa que para aquele caso (linha), a variável (coluna) não foi identificada; a variável será tratada como ausente.
            </p>
            <br />

            <b>Uma variável foi referida mais do que uma vez pelo mesmo caso. Que valor coloco na célula?</b>
            <p>
                Pode acontecer que a mesma variável seja identificada mais do que uma vez, pelo mesmo caso.
            </p>
            <p>
                Nestas situações, dever-se-á incluir na célula o peso (valor) mais elevado (ver Sales & Wakker, 2009, p. 675).
            </p>
            <br />

            <b>Como transformar a matriz do MF calculator numa matriz de proximidade do SPSS?</b>
            <p>
                Para importar ficheiros CSV no SPSS, pode abrir o menu "Text import wizard" e escolher "Semicolon" em "Which delimiters appear between variables".
            </p>
            <p>
                Em alternativa, deverá abrir o ficheiro CSV no MS Excel e gravá-lo nesse formato; em seguida, abrir o ficheiro Excel no SPSS, fazendo os seguintes passos:
                <ul>
                    <li>Verificar se as variáveis <b>ROWTYPE_</b>, <b>CASENO_</b> e <b>VARNAME_</b> mantêm o underscore no nome. 
                        O underscore no nome destas variáveis é obrigatório para que o SPSS reconheça o ficheiro como matriz de distâncias/proximidades. 
                        Se necessário, renomear estas variáveis no variableview
                    </li>
                    <li>
                        No variableview, verificar se a variável ROWTYPE_ tem 8 caracteres de comprimento (width); modificar, se necessário.
                    </li>
                    <li>
                        No variableview, atribuir a etiqueta SIMILARITY ao valor PROX da variável ROWTYPE_ (values)
                    </li>
                </ul>
            </p>
            <p>
                Guardar o ficheiro, ficando este pronto a ser analisado pelo SPSS como matriz de proximidades
            </p>
            <p>
                Os valores do ficheiro aparecerão como 0 ou 1, pois estão sem casas decimais. 
                Se pretender visionar o valor de MF, alterar o número de casas decimais desejado no variableview (decimals)
            </p>
            <br />
                        
            <b>Depois de importar a matriz MF para o SPSS, não aparecem os valores do MF no dataview. O que posso fazer?</b>
            <p>
                Poderá haver alguma incompatibilidade entre as versões do Excel em que gravou do ficheiro CSV e a sua versão do SPSS.
            </p>
            <p>
                Importe então preferencialmente o ficheiro CSV através do “Text import wizard”.
            </p>
            <p>
                Pode ainda tentar abrir o ficheiro CSV no MS Excel e substituir todas as vírgulas por pontos, gravar como Excel e abrir novamente no SPSS.
            </p>
        </asp:PlaceHolder>
    </div>
</div>
</asp:Content>
