﻿using System;
using System.Collections;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.Xml.Linq;
using System.IO;
using System.Web.SessionState;

namespace MFCalculator
{
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    public class FileHandler : IHttpHandler, IReadOnlySessionState, IRequiresSessionState
    {
        public void ProcessRequest(HttpContext context)
        { 
            string strFileName = Path.GetFileName(context.Request.Files[0].FileName);
            string strExtension = Path.GetExtension(context.Request.Files[0].FileName).ToLower();

            if (String.IsNullOrEmpty((String)context.Session["GUID"]))
                context.Session.Add("GUID", System.Guid.NewGuid().ToString());
            string strguid = context.Session["GUID"].ToString();

            string strSaveLocation = context.Server.MapPath("~/temporaryFiles/" + strguid + "/");

            if (strExtension.Equals(".mfc") || strExtension.Equals(".csv"))
            {
                DirectoryInfo dir = new DirectoryInfo(context.Server.MapPath("~/temporaryFiles/"));
                dir.CreateSubdirectory(strguid);
                context.Request.Files[0].SaveAs(strSaveLocation + strFileName);
                context.Response.ContentType = "text/plain";
                context.Response.Write(strguid);
                context.Session.Add(strFileName, strFileName);
            }
            else 
            {
                context.Response.ContentType = "text/plain";
                context.Response.Write("failure");
            }
        }

        public bool IsReusable
        {
            get
            {
                return false;
            }
        }
    }
}
