﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Text;
using System.IO;

namespace MFCalculator
{
    public partial class Layout : System.Web.UI.MasterPage
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            // Logo
            //forlogo.Style.Add("background-image", "url('../Images/MF-FUNDOPRETO-COR-LETRAS.png')");
            if (Request.QueryString["logo"] != null)
            {
                forlogo.Style.Remove("background-image");
                if (Request.QueryString["logo"].ToString().Equals("1"))
                    forlogo.Style.Add("background-image", "url('../Images/MF-FUNDOBRANCO-LETRAS.png')");
                if (Request.QueryString["logo"].ToString().Equals("2"))
                    forlogo.Style.Add("background-image", "url('../Images/LogoISCTE.png')");
                if (Request.QueryString["logo"].ToString().Equals("3"))
                    forlogo.Style.Add("background-image", "url('../Images/MF-BRANCOEPRETO-LETRAS.png')");
            }

            if ((Page as BasePage).SiteCulture == "pt-PT")
            {
                IBPT.ImageUrl = "~/Images/PTDisable.png";
                IBPT.Attributes.Clear();
                IBPT.Attributes.Add("onclick", "return false;");
                IBPT.Enabled = false;
            }
            else
            {
                IBEN.ImageUrl = "~/Images/ENDisable.png";
                IBEN.Attributes.Clear();
                IBEN.Attributes.Add("onclick", "return false;");
                IBEN.Enabled = false;
            }

            ApagaFicheiros();
        }

        protected void HLSSession_Click(object sender, EventArgs e)
        {
            int linhas = Session.Count; // numero de ficheiros 
            
            if (Session["GUID"] != null)
            {
                if (Directory.Exists(Server.MapPath("~/temporaryFiles/") + Session["GUID"].ToString() + "/"))
                {
                    DirectoryInfo dir = new DirectoryInfo(Server.MapPath("~/temporaryFiles/") + Session["GUID"].ToString() + "/");
                    FileInfo[] file = dir.GetFiles();

                    foreach (FileInfo f in file)
                        File.Delete(f.FullName);

                    dir.Delete();
                }

                Session.Abandon();
            }

            Response.Redirect("~/default.aspx");
        }

        private void ApagaFicheiros() {

            DirectoryInfo dir = new DirectoryInfo(Server.MapPath("~/temporaryFiles/"));
            DateTime nowDate = DateTime.Now;
            DirectoryInfo[] subDirs = dir.GetDirectories();

            foreach (DirectoryInfo d in subDirs)
            {
                FileInfo[] file = d.GetFiles();

                if (!d.Name.Equals(".svn"))
                {
                    DateTime datefile = d.CreationTime;
                    TimeSpan span = nowDate - datefile;

                    if ((int)span.TotalDays >= 1)
                    {
                        foreach (FileInfo f in file)
                            File.Delete(f.FullName);
                        d.Delete();
                    }
                }
            }
        }

        protected void IBEN_Click(object sender, ImageClickEventArgs e)
        {
            (Page as BasePage).SiteCulture = "en";

            IBPT.Enabled = true;
            IBEN.Enabled = false;
            IBPT.ImageUrl = "~/Images/PT.png";
            IBEN.ImageUrl = "~/Images/ENDisable.png";

            Response.Redirect(Page.Request.Url.AbsoluteUri.ToString());
        }

        protected void IBPT_Click(object sender, ImageClickEventArgs e)
        {
            (Page as BasePage).SiteCulture = "pt";

            IBPT.Enabled = false;
            IBEN.Enabled = true;
            IBPT.ImageUrl = "~/Images/PTDisable.png";
            IBEN.ImageUrl = "~/Images/EN.png";

            Response.Redirect(Page.Request.Url.AbsoluteUri.ToString());
        }
    }
}
