﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Drawing;
using System.IO;
using System.Text;
using createWordExcel;

namespace MFCalculator
{
    public partial class ViewTree : BasePage
    {
        ArrayList listaNomes = null;

        protected void Page_Load(object sender, EventArgs e)
        {
            LTree.Text = "";

            if (Request.QueryString["fileId"] != null && Request.QueryString["nFactor"] != null &&
                Request.QueryString["scoreVSfrenquency"] != null && Request.QueryString["viewType"] != null)
            {
                try
                {
                    int fileId = Convert.ToInt32(Request.QueryString["fileId"]);
                    int nFactor = Convert.ToInt32(Request.QueryString["nFactor"]);
                    int scoreVSfrenquency = Convert.ToInt32(Request.QueryString["scoreVSfrenquency"]);
                    int viewType = Convert.ToInt32(Request.QueryString["viewType"]);

                    ArrayList tabelaGtree = GetGtreeTable(fileId, nFactor, scoreVSfrenquency, (MFC.CalculationType)viewType);

                    Tree gt = new Tree(listaNomes, tabelaGtree);
                    LTree.Text = gt.getTreeGrafic();
                }
                catch (Exception err)
                {
                    HFClose.Value = err.Message;
                }
            }
            else
            {
                HFClose.Value = "1";
            }
        }

        private ArrayList GetGtreeTable(int fileId, int nFactor, int scoreVSfrenquency, MFC.CalculationType type)
        {
            ArrayList lista = new ArrayList();
            ArrayList sublista = null;

            listaNomes = new ArrayList();

            var mfc = GetCalculator(fileId, nFactor, scoreVSfrenquency, false);

            for (int i = 0; i < mfc.NumberOfPersons; i++)
                listaNomes.Add(mfc.Persons[i].Name);

            for (var line = 0; line < mfc.NumberOfPersons; line++)
            {
                sublista = new ArrayList();

                for (var column = 0; column < mfc.NumberOfPersons; column++)
                {
                    if (line > column && column > 0)
                        sublista.Add(((double)(mfc.GetMfcValue(type, line, column)) * 100));
                }

                if (line > 0)
                    lista.Add(sublista);
            }

            return lista;
        }

        protected void IBExcel_Click(object sender, ImageClickEventArgs e)
        {
            if (Session["GUID"] == null)
                return;

            String aux = LTree.Text;
            aux = "\n " + aux.Replace("<br />", "\n");

            TextWriter tw = new StreamWriter(Server.MapPath("~/temporaryFiles/" + Session["GUID"].ToString() + "/") + "gtree.xls");
            tw.WriteLine(aux);
            tw.Close();
            
            Response.Redirect("./temporaryFiles/" + Session["GUID"].ToString() + "/" + "gtree.xls");

            //string caminho=Server.MapPath("~/temporaryFiles/" + Session["GUID"].ToString() + "/");
            //Create.excel(caminho + "gtree.gif", caminho + "gtree.xlsx");

            //Response.AddHeader("Content-Disposition", "attachment; filename=" + "gtree.xlsx");
            //Response.TransmitFile(caminho + "gtree.xlsx");
            //Response.End();
        }

        protected void IBWord_Click(object sender, ImageClickEventArgs e)
        {
            if (Session["GUID"] == null)
                return;

            String aux = LTree.Text;
            aux = "\n " + aux.Replace("<br />", "\n");
            
            TextWriter tw = new StreamWriter(Server.MapPath("~/temporaryFiles/" + Session["GUID"].ToString() + "/") + "gtree.doc");
            tw.WriteLine(aux);
            tw.Close();
            
            Response.Redirect("./temporaryFiles/" + Session["GUID"].ToString() + "/" + "gtree.doc");

            //string caminho = Server.MapPath("~/temporaryFiles/" + Session["GUID"].ToString() + "/");
            //Create.word(caminho + "gtree.gif", caminho + "gtree.docx");

            //Response.AddHeader("Content-Disposition", "attachment; filename=" + "gtree.docx");
            //Response.TransmitFile(caminho + "gtree.docx"); 
            //Response.End();
        }
    }
}
